unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls{, MPlayer}, Unit3, Unit4, Unit5, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Game1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    View1: TMenuItem;
    Orders1: TMenuItem;
    Screenshot1: TMenuItem;
    SetMode1: TMenuItem;
    ShowTroops: TMenuItem;
    ShowTactics: TMenuItem;
    ShowBases: TMenuItem;
    Image1: TImage;
    New1: TMenuItem;
    Pause1: TMenuItem;
    KI1: TMenuItem;
    DoTactics1: TMenuItem;
    DoBattles1: TMenuItem;
    Credits1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure Screenshot1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Orders1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SetMode1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ShowBasesClick(Sender: TObject);
    procedure ShowTroopsClick(Sender: TObject);
    procedure ShowTacticsClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure Pause1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DoTactics1Click(Sender: TObject);
    procedure DoBattles1Click(Sender: TObject);
    procedure Credits1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    NotFirstSize:Boolean;
  end;

var
  Form1: TForm1;
  Thread:MyThread;

implementation

uses Unit2, Unit7, Unit6;

{$R *.DFM}

function Max(a, b:Integer):Integer;
begin
  if a>b then Max:=a else Max:=b;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Screen:TScreen;
  Buf:TBitmap;
begin
  if SOUNDDEBUG then DebugNum(100);
  Caption:='The Nebula Conflict '+VERSION;
  Screen:=TScreen.Create(Form2);
{  Form5.Show;}
{  Form5.Label1.Caption:='Starting Game...';
  Form5.ProgressBar1.Position:=1;
  Form5.Label2.Caption:='1%';}
{  MediaPlayer1.FileName:='c:\sys\win95\media\ding.wav';
  MediaPlayer1.DeviceType:=dtWaveAudio;
  MediaPlayer1.Open;
  MediaPlayer1.Play;}
  Height:=Height-ClientHeight mod 2;
  Width:=Width-ClientWidth mod 2;
  Top:=Max((Screen.Height-Height) div 2-40, 0);
  Screen.Free;
  Buf:=TBitmap.Create;
  Buf.Width:=Form1.ClientWidth;
  Buf.Height:=Form1.ClientHeight;
  Buf.PixelFormat:=pfDevice;
  Buf.Canvas.Brush.Color:=clBlack;
  Buf.Canvas.FillRect(Buf.Canvas.ClipRect);
  Form1.Image1.Picture.Bitmap.Assign(Buf);
  Buf.Destroy;
  if SOUNDDEBUG then DebugNum(101);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  if NotFirstSize then begin
    Height:=Height-ClientHeight mod 2;
    Width:=Width-ClientWidth mod 2;
    ReInitOffscreen:=True;
//    Form1.Caption:='!';
  end;
end;

procedure GameTerminate;
begin
  Form5.Show;
  Form5.Label1.Caption:='Terminating...';
  Form5.ProgressBar1.Position:=10;
  Form5.Label2.Caption:='10%';
  Thread.Terminate;
  Form5.ProgressBar1.Position:=20;
  Form5.Label2.Caption:='20%';
{  while not Thread.Finished do
  begin
    Sleep(10);
    Application.ProcessMessages;
  end;}
  Thread.WaitFor;
  Sleep(10);
  Application.Processmessages;
  Form5.ProgressBar1.Position:=90;
  Form5.Label2.Caption:='90%';
  Form5.ProgressBar1.Position:=100;
  Form5.Label2.Caption:='100%';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveCanceled:=False;
  if GameTime-LastSaved>15 then begin
    if Application.MessageBox('Would you like to save your game first?', 'A simple question', MB_YESNO)=IDYES then begin
      Sleep(10);
      DoSaveGame;
      Sleep(10);
    end;
  end;
  if SaveCanceled then
    Action:=caNone
  else
  begin
    Sleep(10);
    GameTerminate;
    Sleep(10);
    Halt;
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  SaveCanceled:=False;
  if GameTime-LastSaved>15 then begin
    if Application.MessageBox('Would you like to save your game first?', 'A simple question', MB_YESNO)=IDYES then begin
      DoSaveGame;
    end;
  end;
  if not SaveCanceled then
  begin
    GameTerminate;
    Halt;
  end;
end;

procedure TForm1.Screenshot1Click(Sender: TObject);
begin
  Image1.Picture.Graphic.SaveToFile('Screenshot.bmp');
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  StartGame:=True;
end;

procedure TForm1.Orders1Click(Sender: TObject);
begin
  Orders1.Checked:=not Orders1.Checked;
  case GameMode of
    1:begin
        if Orders1.Checked then Form7.Show
        else Form7.Hide;
        Form2.Hide;
      end;
    2:begin
        if Orders1.Checked then Form2.Show
        else Form2.Hide;
        Form7.Hide;
      end;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  MyKeyHandler(Sender, Key);
end;

procedure TForm1.SetMode1Click(Sender: TObject);
begin
  case GameMode of
    1:EnterBattle:=True;
    2:LeaveBattle:=True;
  end;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  PaintBox1MouseDown(Sender, Button, Shift, X, Y);
end;

procedure TForm1.ShowBasesClick(Sender: TObject);
begin
  ShowBases.Checked:=not ShowBases.Checked;
end;

procedure TForm1.ShowTroopsClick(Sender: TObject);
begin
  ShowTroops.Checked:=not ShowTroops.Checked;
end;

procedure TForm1.ShowTacticsClick(Sender: TObject);
begin
  ShowTactics.Checked:=not ShowTactics.Checked;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (MClick<>2)and(Button=mbLeft) then MClick:=1;
  if (MClick<>2)and(Button=mbRight) then MClick:=4;
  ClickX:=X;
  ClickY:=Y;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
  MClick:=2;
end;

procedure TForm1.Pause1Click(Sender: TObject);
begin
  Pause1.Checked:=not Pause1.Checked;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  ClickX:=X;
  ClickY:=Y;
end;

procedure TForm1.DoTactics1Click(Sender: TObject);
begin
  DoTactics1.Checked:=not DoTactics1.Checked;
end;

procedure TForm1.DoBattles1Click(Sender: TObject);
begin
  DoBattles1.Checked:=not DoBattles1.Checked;
end;

procedure TForm1.Credits1Click(Sender: TObject);
begin
  EnterCredits:=True;
end;

procedure TForm1.Load1Click(Sender: TObject);
begin
  LoadGame:=True;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  SaveGame:=True;
end;

end.
