unit Unit3;

interface

uses
  Windows, Classes, Forms, Graphics, SysUtils, Unit4, ExtCtrls, Registry;//, MPlayer;

type
  MyThread = class(TThread)
  private
    { Private-Deklarationen }
  protected
    procedure Execute; override;
  public
    Finished:Boolean;
    constructor Create;
  end;

procedure CheckRelay(N:Integer);
procedure DoMoveOnce(From, Two, Fig, Bom, Des:Integer);
procedure MyKeyHandler(Sender:TObject; Key:Char);
procedure CheckBaseInfo;
procedure DoEnterBattle;
procedure DoLeaveBattle;
procedure DoSaveGame;
function Max(a, b:Integer):Integer;
function Min(a, b:Integer):Integer;
procedure BRemove(Race:Integer; Fighters, Bombers, Destroyers:Integer);
procedure DebugNum(N:Integer);

const
  SMOKESPOTS=2048;
  OOSQRT32=45;               // Trunc((zoom/sqrt(2))*32)-ca.4  Momentan: zoom=2
  TIMERS=8;
  BASES=120; //gerade Anzahl
  RACES=3;
  GROUPS=BASES*4;
  MAXBASEFIGHTERS=10;
  MAXBASEBOMBERS=4;
  MAXBASEDESTROYERS=2;
  GROUPSPEED=2;
  BATTLESPEED=0.3;
  CREINFINTERVAL=4;
  NUMREINFBASES=4;
  TIMEACC=1;
  FAST1KI=False;
  DEBUG:Boolean=False;
  MOREDEBUG:Boolean=False;
  SOUNDDEBUG:Boolean=False;
  BLOCKTIMING:Boolean=False;
  KITIMING:Boolean=False;
  SOUNDTIMING:Boolean=False;
  CALCBASEINT=0.5;
  CALCTARGETINT=1;
  KIORDERINT=0.5;
  KIORDERNUM=4;
  FIGHTERSPEED=0.006;
  BOMBERSPEED=0.002;
  DESTROYERSPEED=0.001;
  SOUNDS=2; // Players
  LOADDEBUG:Boolean=False;
  NUMTHEMES=1;
  MAXHITFX=10;
  NUMSTARS=1000;
  VERSION='1.01';

type
  tpixline=Array[0..65535] of Word;
  ppixline=^tpixline;
  TTable=Array[Byte] of Single;
  TTable512=Array[Byte] of Integer;
  TRTroops=Record
             Fighters, Bombers, Destroyers:Integer;
           End;
  TRHitTroops=Record
             Fighters, Bombers, Destroyers:Single;
           End;
  TTroops=Record
            Race:Array[1..RACES] of TRTroops;
          End;
  THitTroops=Record
            Race:Array[1..RACES] of TRHitTroops;
          End;
  TGroup=Record
           Used:Boolean;
           Owner:Byte;
           Troops:TRTroops;
           Dest:Integer;
           X, Y:Single;
         End;
  TBase=Record
          X, Y:Single;
          Owner:Byte;
          Troops, Coming:TTroops;
          MoveTo:Integer;
          Defend:TRTroops;
          Battle, Attacked:Boolean;
        End;
  PBattle=^TBattle;
  TBattle=Record
            Base:Integer;
            Next:PBattle;
            Hits:THitTroops;
          End;
  SmokeSpot=Record
              X, Y, Z, SpeedX, SpeedY:Single;
              Timer:Single;
              Color:Word;
              Used:Boolean;
            End;
  TZBuffer=Array [0..16777216] of Byte;
  TGObject=Record
             VO:TVoxelObj;
             X,Y,Z:Single;
             xx,xy,xz,yx,yy,yz,zx,zy,zz:Integer;
             Pitch, Yaw, Roll, dYawv, dYaw, dYawf:Single;
             Speed:Single;
             CreateBuf:Boolean;
           End;
  TBShipKI=Record // AI
             State:Integer;
             Since:Single;
             AttackedBy:Integer;
           end;
  PBShip=^TBShip;
  THits=Record
          Anz:Byte;
          X, Y:Array [1..MAXHITFX] of shortint;
        End;
  TBShip=Record
           Graphic:TGObject;
           Hitp:Integer;
           Hits:THits;
           Lastshot:Single;
           Race:Integer;
           Typ:Integer;
           KI:TBShipKI; //AI
           ID:Integer;// for formations
           Target:PBShip;
           Next:PBShip;
         End;
  PShot=^TShot;
  TShot=Record
          X, Y:Single;
          dX, dY:Single;
          Typ:Integer;
          LaunchedAt:Single;
          Owner:Integer;
          Next:PShot;
        End;
  PReInf=^TReInf;
  TReinf=Record
           Race:Integer;
           Troops:TRTroops;
           Time:Single;
           Done:Boolean;
           StoryID:Integer;
           Next:PReInf;
         End;
  TGTarget=Record
             Race, Typ:Integer;
           End;
  TRGroupKI=Record // AI
              Target:Array[1..3] of TGTarget;
            End;
  TBGroupKI=Record // AI
             Race:Array[1..RACES] of TRGroupKI;
           End;
  PViewSpot=^TViewSpot;
  TViewSpot=Record
              Timer:Single;
              X, Y:Single;
              Next:PViewSpot;
            End;
  TBView=Record
    Base:Integer;
    BShips:PBShip;
    Shots:PShot;
    BGroupKI:TBGroupKI; // AI
    STypSel:Integer;
    ViewSpots:PViewSpot;
  end;
  TRReInfBases=Record
                 Base:Array [1..NUMREINFBASES] of Integer;
               End;
  TReInfBases=Record
                Race:Array [1..RACES] of TRReInfBases;
              End;
  TView=Record
          X, Y, dX, dY:Single;
          Zoom, dZoom:Single;
        End;
  TCredits=Record
             Time:Single;
             LastBird:Single;
             GameStatus:Integer;
           End;
  TStar=Record
          X,Y,Z:Single;
          Color:Word;
        End;

var
  StartStory, StartGame, ReInitOffscreen, RepaintMap, ReInitGame, EnterBattle, LeaveBattle:Boolean;
  NumSelected:Boolean;
  GameMode:Integer;//1:Map, 2:Battle
  StoryPart:Integer;
  CalcBaseTime, CalcTargetTime:Single;
  SWidth, SHeight:Integer;
  pl:ppixline;
  Pps, Fps:Single;
  Reinforcements:PReInf;
  cnt:longint;
  CopyTried:Boolean;
  LastSmokeTime:Single;
  LastKIOrder:Array[1..RACES] of Single; // AI
  KIOrdersLeft:Array[1..RACES] of Integer; // AI
  ReInfBases:TReInfBases;
  Smoke:Array [1..SMOKESPOTS] of SmokeSpot;
  LastTm:Comp;
  Tm1, Tm2:Array [1..TIMERS] of Comp;
  Msecs:Array [1..TIMERS] of Single;
  SinT, CosT:TTable;
  SinO512T, CosO512T:TTable512;
//  P2d:TBitmap;
  NebulaMap:TBitmap;
  Base:Array [1..BASES] of TBase;
  NSel:Integer;
  Group:Array[1..GROUPS] of TGroup;
  Offscreen:TBitmap;
  Battles:PBattle;
  Gametime, LastCReInftime:Single;
  MClick, ClickX, ClickY:Integer;
  MoveOrder, TacticsOrder:Boolean;
  BView:TBView;
  View:TView;
  MyRandSeed:LongInt;
  LastSaved:Single;
  SaveCanceled:Boolean;
  Credits:TCredits;
  EnterCredits:Boolean;
//  MState:Array [1..SOUNDS] of Integer;
  LoadGame, SaveGame:Boolean;
  Filecom:Integer;
  ThemeNr:Integer;
  HelpMsg:String;
  Stars:Array[1..NUMSTARS] of TStar;

implementation

uses Unit1, Unit5, Unit7, Unit2, Unit6, Unit8;

constructor MyThread.Create;
begin
  Finished:=False;
  inherited Create(False);
end;

procedure MyKeyHandler(Sender:TObject; Key:Char);
begin
  if Upcase(Key)='M' then Form7.MoveOnceClick(Sender);
  if Upcase(Key)='T' then Form7.SetMovementClick(Sender);
end;

procedure DebugNum(N:Integer);
var
  F:Text;
begin
  AssignFile(F, 'Debug.txt');
  Rewrite(F);
  Write(F, IntToStr(N));
  CloseFile(F);
end;

function cut(N:Integer):Integer;
var NO:Integer;
begin
  NO:=N;
  if NO<-(SHeight-1)*SWidth then NO:=-(SHeight-1)*SWidth;
  if NO>SWidth-1 then NO:=SWidth-1;
  cut:=NO;
end;

procedure StartTimer(t:Integer);
begin
  Tm1[t]:=TimeStampToMSecs(DateTimeToTimeStamp(Time));
end;

procedure StopTimer(t:Integer);
begin
  Tm2[t]:=TimeStampToMSecs(DateTimeToTimeStamp(Time));
end;

procedure DrawVoxObj(var VoxObj:TGObject; VAnz:Integer);
var i, j:0..16777216;
    YW, WJ, TY, TX, TW, TH, TYJ:Integer;
    X, Y, X14, Y14, DX, DY:Longint;
    xx2,xy2,xz2,yx2,yy2,yz2,zx2,zy2,zz2:Integer;
    gxx, gxy, gxz, gyx, gyy, gyz, gzx, gzy, gzz:Integer;
    Color:Word;
    Anz, Start:Integer;
    Vox:PVoxelArray;
    SWidth, SHeight:Integer;
    pl2:ppixline;
begin
//    if DEBUG then DebugNum(64);
  if (VoxObj.CreateBuf)
  and(VoxObj.VO.BufFilled)
  and(VoxObj.VO.BufAngle=Trunc(VoxObj.Yaw) and 255) then VoxObj.CreateBuf:=False;
  if (VoxObj.CreateBuf)and(Trunc(VoxObj.Roll) and 255=0) then begin
//    if DEBUG then DebugNum(17);
    SWidth:=256;
    SHeight:=256;
    pl2:=VoxObj.VO.Buf.Scanline[0];
    DX:=127;
    DY:=127;
    for i:=0 to SHeight-1 do begin
      FillChar(pl2^[-i*SWidth], SWidth*2, 0);
    end;
{      VoxObj.VO.Buf.ReleaseMaskHandle;}
{      VoxObj.VO.Buf.Transparent:=False;
    VoxObj.VO.Buf.Transparent:=True;}
  end else begin
//    if DEBUG then DebugNum(18);
    SWidth:=Offscreen.Width;
    SHeight:=Offscreen.Height;
    pl2:=pl;
    DX:=SWidth shr 1+Trunc((VoxObj.X+View.X)*View.Zoom);
    DY:=SHeight shr 1+Trunc((VoxObj.Y+View.Y)*View.Zoom);
  end;
//    pl2:=VoxObj.VO.Buf.Scanline[0];
{    pl:=NebulaMap.ScanLine[0];
  SWidth:=NebulaMap.SWidth;
  SHeight:=NebulaMap.SHeight;}
{    SWidth:=P2d.SWidth;
  SHeight:=P2d.SHeight;
  pl2:=P2d.Scanline[0];}
{    SWidth:=Offscreen.SWidth;
  SHeight:=Offscreen.SHeight;
  pl2:=pl;
  for i:=0 to SHeight-1 do begin
    FillChar(pl2^[-i*SWidth], SWidth*2, 0);
  end;}
//    pl2:=pl;
  if ((not VoxObj.VO.BufFilled)
  or(VoxObj.VO.Bufangle<>Trunc(VoxObj.Yaw) and 255)
  or(Trunc(VoxObj.Roll) and 255<>0)
  or(Trunc(VoxObj.Pitch) and 255<>0))
  and(VoxObj.VO.Anz<>0) then begin
//    if DEBUG then DebugNum(19);
    with VoxObj do begin
      If Roll<>0 then begin
        //xx Achse im VoxObj, Screen-Koordinate
//        xx:=OOSQRT32*Cos512T[Trunc(Roll/(2*PI)*256)];
        xx:=CosO512T[Trunc(Roll) and 255];
        xy:=0;
        xz:=SinO512T[Trunc(Roll) and 255];
        yx:=0;
        yy:=OOSQRT32*512;
        yz:=0;
        zx:=-SinO512T[Trunc(Roll) and 255];
        zy:=0;
        zz:=CosO512T[Trunc(Roll) and 255];
        if Pitch<>0 then begin
//          xx:=xx;
          xy2:=Trunc(xy*CosT[Trunc(Pitch) and 255]+xz*SinT[Trunc(Pitch) and 255]);
          xz2:=Trunc(-xy*SinT[Trunc(Pitch) and 255]+xz*CosT[Trunc(Pitch) and 255]);
//          yx:=yx;
          yy2:=Trunc(yy*CosT[Trunc(Pitch) and 255]+yz*SinT[Trunc(Pitch) and 255]);
          yz2:=Trunc(-yy*SinT[Trunc(Pitch) and 255]+yz*CosT[Trunc(Pitch) and 255]);
//          zx:=zx;
          zy2:=Trunc(zy*CosT[Trunc(Pitch) and 255]+zz*SinT[Trunc(Pitch) and 255]);
          zz2:=Trunc(-zy*SinT[Trunc(Pitch) and 255]+zz*CosT[Trunc(Pitch) and 255]);
          xy:=xy2;
          xz:=xz2;
          yy:=yy2;
          yz:=yz2;
          zy:=zy2;
          zz:=zz2;
        end;
        xx2:=Trunc(xx*CosT[Trunc(Yaw) and 255]-xy*SinT[Trunc(Yaw) and 255]);
        xy2:=Trunc(xx*SinT[Trunc(Yaw) and 255]+xy*CosT[Trunc(Yaw) and 255]);
//        xz:=xz;
        yx2:=Trunc(yx*CosT[Trunc(Yaw) and 255]-yy*SinT[Trunc(Yaw) and 255]);
        yy2:=Trunc(yx*SinT[Trunc(Yaw) and 255]+yy*CosT[Trunc(Yaw) and 255]);
//        yz:=yz;
        zx2:=Trunc(zx*CosT[Trunc(Yaw) and 255]-zy*SinT[Trunc(Yaw) and 255]);
        zy2:=Trunc(zx*SinT[Trunc(Yaw) and 255]+zy*CosT[Trunc(Yaw) and 255]);
//        zz:=zz;
        xx:=xx2;
        xy:=xy2;
        yx:=yx2;
        yy:=yy2;
        zx:=zx2;
        zy:=zy2;
      end else begin
        if Pitch<>0 then begin
          xx:=OOSQRT32*512;
          xy:=0;
          xz:=0;
          yx:=0;
          yy:=CosO512T[Trunc(Pitch)];
          yz:=-SinO512T[Trunc(Pitch)];
          zx:=0;
          zy:=SinO512T[Trunc(Pitch)];
          zz:=CosO512T[Trunc(Pitch)];
          xx2:=Trunc(xx*CosT[Trunc(Yaw) and 255]-xy*SinT[Trunc(Yaw) and 255]);
          xy2:=Trunc(xx*SinT[Trunc(Yaw) and 255]+xy*CosT[Trunc(Yaw) and 255]);
//          xz:=xz;
          yx2:=Trunc(yx*CosT[Trunc(Yaw) and 255]-yy*SinT[Trunc(Yaw) and 255]);
          yy2:=Trunc(yx*SinT[Trunc(Yaw) and 255]+yy*CosT[Trunc(Yaw) and 255]);
//          yz:=yz;
          zx2:=Trunc(zx*CosT[Trunc(Yaw) and 255]-zy*SinT[Trunc(Yaw) and 255]);
          zy2:=Trunc(zx*SinT[Trunc(Yaw) and 255]+zy*CosT[Trunc(Yaw) and 255]);
//          zz:=zz;
          xx:=xx2;
          xy:=xy2;
          yx:=yx2;
          yy:=yy2;
          zx:=zx2;
          zy:=zy2;
        end else begin
          xx:=CosO512T[Trunc(Yaw) and 255];
          xy:=SinO512T[Trunc(Yaw) and 255];
          xz:=0;
          yx:=-SinO512T[Trunc(Yaw) and 255];
          yy:=CosO512T[Trunc(Yaw) and 255];
          yz:=0;
          zx:=0;
          zy:=0;
          zz:=OOSQRT32*512;
        end;
      end;
      gxx:=Trunc(xx*View.Zoom);
      gxy:=Trunc(xy*View.Zoom);
//      gxz:=Trunc(xz*View.Zoom);
      gyx:=Trunc(yx*View.Zoom);
      gyy:=Trunc(yy*View.Zoom);
//      gyz:=Trunc(yz*View.Zoom);
      gzx:=Trunc(zx*View.Zoom);
      gzy:=Trunc(zy*View.Zoom);
//      gzz:=Trunc(zz*View.Zoom);
    end;
    if (VoxObj.Roll=0)and(VoxObj.Pitch=0)and(VAnz=VoxObj.VO.Anz) then begin
      Vox:=VoxObj.VO.Plane;
      Anz:=VoxObj.VO.AnzPlane-1;
      Start:=0;
    end else begin
      Vox:=VoxObj.VO.Vox;
      if VAnz=VoxObj.VO.Anz then begin
        Anz:=VAnz-1;
        Start:=0;
      end else begin
        Anz:=(VoxObj.VO.Anz-VAnz) div 4+VAnz-1;
        Start:=(VoxObj.VO.Anz-VAnz) div 4;
      end;
    end;
    if VoxObj.zz>=0 then begin
//      if DEBUG then DebugNum(20);
      for i:=Start to Anz do begin
        X14:=(Vox^[i].X-128)*gxx
            +(Vox^[i].Y-128)*gyx
            +(Vox^[i].Z-128)*gzx
            +16777216;
        Y14:=(Vox^[i].X-128)*gxy
            +(Vox^[i].Y-128)*gyy
            +(Vox^[i].Z-128)*gzy
            +16777216;
{          Z14:=(Vox^[i].X-128)*gxz
            +(Vox^[i].Y-128)*gyz
            +(Vox^[i].Z-128)*gzz
            +16777216;}
        X:=DX+(X14 shr 14-1024);
        Y:=DY+(Y14 shr 14-1024);
//          Z:=Trunc(VoxObj.Z)+(Z14 shr 14-1024);
        Color:=Vox^[i].Color;
        if (Color=$F800)or(Color=$F800+32*63) then begin
          {if Random(4)=0 then }Color:=$F800+32*Random(64)
{          else Color:=0;}
        end;
        if (Y>=0)and(Y<=SHeight-2)and(X>=0)and(X<=SWidth-2) then begin
          YW:=Trunc(Y)*SWidth;
          pl2^[Trunc(X)-YW]:=Color;
          pl2^[Trunc(X)+1-YW]:=Color;
          YW:=YW+SWidth;
          pl2^[Trunc(X)-YW]:=Color;
          pl2^[Trunc(X)+1-YW]:=Color;
        end;
      end;
    end else begin
//      if DEBUG then DebugNum(21);
      for i:=Anz downto Start do begin
        X14:=(Vox^[i].X-128)*gxx
            +(Vox^[i].Y-128)*gyx
            +(Vox^[i].Z-128)*gzx
            +16777216;
        Y14:=(Vox^[i].X-128)*gxy
            +(Vox^[i].Y-128)*gyy
            +(Vox^[i].Z-128)*gzy
            +16777216;
{          Z14:=(Vox^[i].X-128)*gxz
            +(Vox^[i].Y-128)*gyz
            +(Vox^[i].Z-128)*gzz
            +16777216;}
        X:=DX+(X14 shr 14-1024);
        Y:=DY+(Y14 shr 14-1024);
//          Z:=Trunc(VoxObj.Z)+(Z14 shr 14-1024);
        Color:=Vox^[i].Color;
        if (Color=$F800)or(Color=$F800+32*63) then begin
          {if Random(4)=0 then }Color:=$F800+32*Random(64)
{          else Color:=0;}
        end;
        if (Y>=0)and(Y<=SHeight-2)and(X>=0)and(X<=SWidth-2) then begin
          YW:=Trunc(Y)*SWidth;
          pl2^[Trunc(X)-YW]:=Color;
          pl2^[Trunc(X)+1-YW]:=Color;
          YW:=YW+SWidth;
          pl2^[Trunc(X)-YW]:=Color;
          pl2^[Trunc(X)+1-YW]:=Color;
        end;
      end;
    end;
  end else begin
//    if DEBUG then DebugNum(22);
    SWidth:=256;
    SHeight:=256;
    pl2:=VoxObj.VO.Buf.Scanline[0];
    TX:=SWidth shr 1+Trunc((VoxObj.X+View.X)*View.Zoom)-127;
    TY:=SHeight shr 1+Trunc((VoxObj.Y+View.Y)*View.Zoom)-127;
    TW:=Offscreen.Width;
    TH:=Offscreen.Height;
    for j:=0 to SHeight-1 do begin
      if (j+TY<=TH-1)and(j+TY>=0) then begin
        WJ:=-SWidth*j;
        TYJ:=TX-TW*(j+TY);
        for i:=0 to SWidth-1 do begin
          if (pl2^[i+WJ]<>0)and(i+TX<=TW-1)and(i+TX>=0) then pl^[i+TYJ]:=pl2^[i+WJ];
        end;
      end;
    end;
  end;
//    P2d.Free;
{    TX:=Trunc(VoxObj.X)-127;
  TY:=Trunc(VoxObj.Y)-127;
  TW:=Offscreen.SWidth;
  for j:=0 to SHeight-1 do begin
    WJ:=-SWidth*j;
    TYJ:=TX-TW*(j+TY);
    for i:=0 to SWidth-1 do begin
      if pl2^[i+WJ]<>0 then pl^[i+TYJ)]:=pl2^[i+WJ];
    end;
  end;}
  if (VoxObj.CreateBuf)and(Trunc(VoxObj.Roll) and 255=0) then begin
//    if DEBUG then DebugNum(23);
    TX:=SWidth shr 1+Trunc((VoxObj.X+View.X)*View.Zoom)-127;
    TY:=SHeight shr 1+Trunc((VoxObj.Y+View.Y)*view.Zoom)-127;
    TW:=Offscreen.Width;
    TH:=Offscreen.Height;
    for j:=0 to SHeight-1 do begin
      if (j+TY<=TH-1)and(j+TY>=0) then begin
        WJ:=-SWidth*j;
        TYJ:=TX-TW*(j+TY);
        for i:=0 to SWidth-1 do begin
          if (pl2^[i+WJ]<>0)and(i+TX<=TW-1)and(i+TX>=0) then pl^[i+TYJ]:=pl2^[i+WJ];
        end;
      end;
    end;
    VoxObj.VO.BufFilled:=True;
    VoxObj.VO.BufAngle:=Trunc(VoxObj.Yaw) and 255;
    VoxObj.CreateBuf:=False;
  end;
//  if DEBUG then DebugNum(24);
end;

function PlaySound(Typ:Integer;Name:String;Force:Boolean):boolean;
{var
  mp:^TMediaPlayer;
  Pre,Path:String;
  Ret:Boolean;}
//  Tm1, Tm2:Comp;
begin
{  Pre:=Application.ExeName;
  while (Pre[length(Pre)]<>'\')and(length(Pre)>0) do SetLength(Pre,length(Pre)-1);
  Ret:=False;
  try
    if SOUNDDEBUG then DebugNum(1001);
      case Typ of
        1:begin
    if SOUNDDEBUG then DebugNum(1002);
            mp:=addr(Form1.MediaPlayer1);
    if SOUNDDEBUG then DebugNum(1003);
            Path:=Pre+'Data\Music\';
    if SOUNDDEBUG then DebugNum(1004);
          end;
        2:begin
    if SOUNDDEBUG then DebugNum(1005);
            mp:=addr(Form1.MediaPlayer2);
    if SOUNDDEBUG then DebugNum(1006);
            Path:=Pre+'Data\Sounds\';
    if SOUNDDEBUG then DebugNum(1007);
          end;
      else
    if SOUNDDEBUG then DebugNum(1008);
        mp:=addr(Form1.MediaPlayer1);
    if SOUNDDEBUG then DebugNum(1009);
        Path:=Pre+'Data\Music\';
    if SOUNDDEBUG then DebugNum(1010);
      end;
      if (mp^.Mode=mpPlaying)and(mp^.FileName<>Path+Name)and(Force) then begin
    if SOUNDDEBUG then DebugNum(1011);
        mp^.Stop;
    if SOUNDDEBUG then DebugNum(1012);
        mp^.Close;
    if SOUNDDEBUG then DebugNum(1013);
        mp^.FileName:=Path+Name;
    if SOUNDDEBUG then DebugNum(1014);
        mp^.Open;
    if SOUNDDEBUG then DebugNum(1015);
        mp^.Play;
    if SOUNDDEBUG then DebugNum(1016);
        Ret:=True;
    if SOUNDDEBUG then DebugNum(1017);
      end
      else if (mp^.Mode=mpPlaying)and(mp^.FileName=Path+Name)and(Force) then begin
    if SOUNDDEBUG then DebugNum(1018);
        mp^.Stop;
    if SOUNDDEBUG then DebugNum(1019);
        mp^.Play;
    if SOUNDDEBUG then DebugNum(1020);
        Ret:=True;
      end
      else if (mp^.Mode<>mpPlaying)and(mp^.FileName<>Path+Name) then begin
    //    StartTimer(1);
    if SOUNDDEBUG then DebugNum(1021);
        mp^.Close;
        mp^.FileName:=Path+Name;
    //    StopTimer(1);
    //    StartTimer(3);
    if SOUNDDEBUG then DebugNum(22);
        mp^.Open;
    //    StopTimer(3);
    //    StartTimer(5);
    if SOUNDDEBUG then DebugNum(1023);
        mp^.Play;
    if SOUNDDEBUG then DebugNum(1024);
    //    StopTimer(5);
      end
      else if (mp^.Mode<>mpPlaying)and(mp^.FileName=Path+Name) then begin
    if SOUNDDEBUG then DebugNum(1025);
        mp^.Play;
    if SOUNDDEBUG then DebugNum(1026);
      end;
    //  Tm:=TimeStampToMSecs(DateTimeToTimeStamp(Time));
    if SOUNDDEBUG then DebugNum(1027);
  except
    on E:EMCIdeviceError do Form1.Caption:=E.Message;
  end;
  PlaySound:=Ret;}
  PlaySound := False;
end;

procedure PlayTheme(Force:boolean);
begin
  //if Playsound(1,'Theme'+IntToStr(ThemeNr mod NUMTHEMES)+'.mid', Force) then Inc(ThemeNr);
end;

procedure StopSound(Typ:Integer);
begin
{if SOUNDDEBUG then DebugNum(200);
  case Typ of
    1:begin
if SOUNDDEBUG then DebugNum(201);
        Form1.MediaPlayer1.Stop;
if SOUNDDEBUG then DebugNum(202);
      end;
    2:begin
if SOUNDDEBUG then DebugNum(203);
        Form1.MediaPlayer2.Stop;
if SOUNDDEBUG then DebugNum(204);
      end;
  end;
if SOUNDDEBUG then DebugNum(205);}
end;

procedure StopMidis;
begin
  //Form1.MediaPlayer1.Stop;
end;

procedure DoReInitOffscreen;
begin
{  if Offscreen.Canvas.TryLock then
  begin}
//  Offscreen.Canvas.Lock;
    if Form1.Image1.Canvas.TryLock then
    begin
      Offscreen.Free;
      Offscreen:=TBitmap.Create;
      Offscreen.Width:=Form1.ClientWidth;
      Offscreen.Height:=Form1.ClientHeight;
      Offscreen.PixelFormat:=pf16bit;
      Offscreen.HandleType:=bmDIB;
      SHeight:=Offscreen.Height;
      SWidth:=Offscreen.Width;
      Form1.Image1.Height:=SHeight;
      Form1.Image1.Width:=SWidth;
      Form1.Image1.Picture.Bitmap.Height:=SHeight;
      Form1.Image1.Picture.Bitmap.Width:=SWidth;
      Form1.Image1.Picture.Bitmap.HandleType:=bmDIB;
      pl:=Offscreen.Scanline[0];
      ReInitOffscreen:=False;
      Form1.Image1.Canvas.UnLock;
    end;
//  Offscreen.Canvas.UnLock;
{    Offscreen.Canvas.UnLock;
  end;}
end;

procedure ClearBuffers;
{var
  i:Integer;
  src, dst:TRect;}
{var
  B:TBrush;}
begin
{  for i:=5 to SHeight-10 do begin
    FillChar(pl^[-i*SWidth+5], SWidth*2-20, 0);
  end;}
{  B:=TBrush.Create;
  B.Color:=clBlack;
  Offscreen.Canvas.FillRect(Offscreen.Canvas.ClipRect);
  B.Destroy;}
{  src.Left:=Trunc(Base[BaseSel].X);
  src.Right:=Trunc(Base[BaseSel].X)+1;
  src.Top:=Trunc(Base[BaseSel].Y);
  src.Bottom:=Trunc(Base[BaseSel].Y)+1;
  dst.Left:=0;
  dst.Right:=SWidth;
  dst.Top:=0;
  dst.Bottom:=SHeight;
  Offscreen.Canvas.CopyRect(dst, NebulaMap.Canvas, src);}
  FillChar(pl^[-(SHeight-1)*SWidth], SHeight*SWidth*2, 0);
end;

procedure InitStars;
var
  i:Integer;
begin
  for i:=1 to NUMSTARS do begin
    Stars[i].Z:=random*1.5;
//    if Random(8)=0 then Stars[i].Z:=1/(Random(100)+1);
    Stars[i].X:=(Random(SWidth*4)-SWidth*2)/Stars[i].Z;
    Stars[i].Y:=(Random(SHeight*4)-SHeight*2)/Stars[i].Z;
    Stars[i].Color:=Random(16)+16;
    Stars[i].Color:=Stars[i].Color+64*Stars[i].Color+2048*Stars[i].Color;
  end;
end;

procedure DrawBackground;
begin
  FillChar(pl^[-(SHeight-1)*SWidth], SHeight*SWidth*2, 0);
end;

function Max(a, b:Integer):Integer;
begin
  if a>b then Max:=a else Max:=b;
end;

function Min(a, b:Integer):Integer;
begin
  if a<b then Min:=a else Min:=b;
end;

procedure CalcSmoke;
var
  i, j:Integer;
  BShp:PBShip;
  Sht:PShot;
begin
  if GameTime-LastSmokeTime>0.05 then begin
    LastSmokeTime:=GameTime;
    BShp:=BView.BShips;
    while BShp<>nil do begin
{      for i:=1 to 1 do begin
        j:=1+Random(SMOKESPOTS);
        with Smoke[j] do begin
          Used:=True;
          X:=BShp.Graphic.X+BShp.Graphic.yx/1200;
          Y:=BShp.Graphic.Y+BShp.Graphic.yy/1200;
          if BShp.Typ=3 then begin
            X:=BShp.Graphic.X+BShp.Graphic.yx/500;
            Y:=BShp.Graphic.Y+BShp.Graphic.yy/500;
          end;
          SpeedX:=0;
          SpeedY:=0;
          Z:=128;
          Timer:=300+Random(300);
          Color:=16+Random(16);
          Color:=Color shl 11+Random(Color) shl 6;
        end;
      end;}
      if (BShp.KI.State=10)or(BShp.KI.State=40)or(BShp.KI.State=41) then
      for i:=1 to 4 do begin
        j:=1+Random(SMOKESPOTS);
        with Smoke[j] do begin
          Used:=True;
          X:=BShp.Graphic.X+BShp.Graphic.yx/5000*Random(10);
          Y:=BShp.Graphic.Y+BShp.Graphic.yy/5000*Random(10);
          SpeedX:=0;
          SpeedY:=0;
          Z:=128;
          Timer:=300+Random(300);
          Color:=$3F;
        end;
      end;
      if BShp.Hits.Anz>0 then
      for i:=1 to BShp.Hits.Anz do begin
        if Random(2)=0 then begin
          j:=1+Random(SMOKESPOTS);
          with Smoke[j] do begin
            Used:=True;
            X:=BShp.Graphic.X+BShp.Hits.X[i]*BShp.Graphic.xx/$4000+BShp.Hits.Y[i]*BShp.Graphic.yx/$4000;
            Y:=BShp.Graphic.Y+BShp.Hits.X[i]*BShp.Graphic.xy/$4000+BShp.Hits.Y[i]*BShp.Graphic.yy/$4000;
            SpeedX:=0;
            SpeedY:=0;
            Z:=128;
            Timer:=300+Random(300);
            Color:=$FFFF;
          end;
        end;
      end;
      BShp:=BShp.Next;
    end;
    Sht:=BView.Shots;
    while Sht<>nil do begin
      if Sht.Typ=2 then begin
        for i:=1 to 6 do begin
          j:=1+Random(SMOKESPOTS);
          with Smoke[j] do begin
            Used:=True;
            X:=Sht.X;
            Y:=Sht.Y;
            SpeedX:=0;
            SpeedY:=0;
            Z:=128;
            Timer:=300+Random(300);
            Color:=16+Random(16);
            Color:=Color shl 11+Random(Color) shl 6;
          end;
        end;
      end;
      Sht:=Sht.Next;
    end;
  end;
end;

procedure DrawSmoke;
var
  i:Integer;
  PX, PY:Integer;
  Move:Boolean;
begin
  Move:=not Form1.Pause1.Checked;
  for i:=1 to SMOKESPOTS do begin
    with Smoke[i] do begin
      if Used then begin
        PX:=SWidth div 2+Trunc((X+View.X)*View.Zoom);
        PY:=SHeight div 2+Trunc((Y+View.Y)*View.Zoom);
        if (PX>=0)and(PX<SWidth-1)and(PY>=0)and(PY<SHeight-1) then begin
          pl^[PX-PY*SWidth]:=Color;
          pl^[PX+1-(PY+1)*SWidth]:=Color;
        end;
        if Move then begin
          X:=X+(Random(31)-15+SpeedX)*Pps/TIMEACC;
          Y:=Y+(Random(31)-15+SpeedY)*Pps/TIMEACC;
          Z:=Z+(Random(11)-5)*Pps/TIMEACC;
          if Z<0 then Z:=0;
          if Z>255 then Z:=255;
          Timer:=Timer-50*Pps/TIMEACC;
          if Color<>$3F then begin
            if Timer<250 then Color:=$FFFF;
            if Timer<200 then Color:=33808;
          end;
        end;
      end;
    end;
  end;
end;

procedure Timing(Disp:Boolean);
var
  Tm:Comp;
  Font:TFont;
  Brush:TBrush;
  i:Integer;
  Sum:Single;
begin
  Tm:=TimeStampToMSecs(DateTimeToTimeStamp(Time));
  if Tm-LastTm>=0 then Pps:=(2*(Pps/TIMEACC)+(Tm-LastTm)/1000)/3*TIMEACC;
  if Tm-LastTm>=0 then Fps:=(19*Fps+(Tm-LastTm)/1000)/20;
  if Pps>0.1*TIMEACC then Pps:=0.1*TIMEACC;
  LastTm:=Tm;
  if Disp then begin
  Font:=TFont.Create;
  Font.Color:=clGray;
  Offscreen.Canvas.Font.Assign(Font);
  Brush:=TBrush.Create;
  Brush.Color:=clBlack;
  Offscreen.Canvas.Brush.Assign(Brush);
//  Application.ProcessMessages;
  Sleep(10);
    if Fps<>0 then begin
//      Offscreen.Canvas.TextOut(200,50,FloatToStr(1/Fps)+' Frames/sec');
    end else begin
//      Offscreen.Canvas.TextOut(200,50,'Infinity Frames/sec');
      Pps:=1E-42;// kleine Zahl
    end;
    Sum:=0;
    for i:=1 to TIMERS do begin
      Sum:=Sum+Msecs[i];
    end;
    for i:=1 to TIMERS do begin
      Msecs[i]:=Msecs[i]+(Tm2[i]-Tm1[i]);
      if Sum<>0 then Offscreen.Canvas.TextOut(200, 50+12*i, FloatToStr(100*Msecs[i]/Sum));
    end;
//    Offscreen.Canvas.TextOut(200,30,'Game Time: '+IntToStr(Trunc(GameTime)));
    Font.Free;
    Brush.Free;
  end;
end;

procedure PreCalcSineTables;
var
  i:Integer;
begin
  for i:=0 to 255 do begin
    SinT[i]:=Sin(i/256*2*PI);
    CosT[i]:=Cos(i/256*2*PI);
    SinO512T[i]:=OOSQRT32*Trunc(512*Sin(i/256*2*PI));
    CosO512T[i]:=OOSQRT32*Trunc(512*Cos(i/256*2*PI));
  end;
end;

procedure CreateNebulaMap(Seed:LongInt);
var
  i, j, k, l, dn:Integer;
  pl2:ppixline;
  pix:^Word;
  Color:Word;
  XEnd, YEnd:Integer;
  UD:Boolean;
begin
  NebulaMap:=TBitmap.Create;
  NebulaMap.Width:=640;
  NebulaMap.Height:=480;
  NebulaMap.PixelFormat:=pf16bit;
  NebulaMap.HandleType:=bmDIB;
  pl2:=NebulaMap.Scanline[0];
  for i:=0 to NebulaMap.Height-1 do begin
    FillChar(pl2^[-i*NebulaMap.Width], NebulaMap.Width*2, 0);
  end;
  RandSeed:=Seed;
  XEnd:=Random(50);
  YEnd:=220-Random(170);
  if Random(2)=0 then UD:=True else UD:=False;
  for i:=0 to 19 do begin
    for j:=0 to 14 do begin
      if UD then dn:=j else dn:=14-j;
      if (abs(i*dn)<YEnd)and(abs(i*dn)>XEnd) then begin
        Color:=64*Min(Min(Min(Random(8), Random(8)),Min(Random(8), Random(8))),
                        Min(Min(Random(8), Random(8)),Min(Random(8), Random(8))))*7
              +Min(Min(Min(Random(10), Random(10)),Min(Random(10), Random(10))),
                   Min(Min(Random(10), Random(10)),Min(Random(10), Random(10))))*10;
      end else Color:=0;
      for k:=0 to 31 do begin
        for l:=0 to 31 do begin
          pl2^[i*32+k-(j*32+l)*NebulaMap.Width]:=Color;
        end;
      end;
    end;
  end;
  for k:=1 to 10 do begin
    for i:=0 to 639 do begin
      for j:=0 to 479 do begin
        pl2^[i-j*NebulaMap.Width]:=(pl2^[i-j*NebulaMap.Width] and $F7DF
                                   +pl2^[Max(Min(i+40-Random(81),639), 0)-Max(Min(j+40-Random(81),479), 0)*NebulaMap.Width] and $F7DF+64+4097) div 2;
      end;
    end;
  end;
  for i:=1 to 300 do begin
    Color:=Random(32);
    pix:=Addr(pl2^[Random(NebulaMap.Width)-Random(NebulaMap.Height)*NebulaMap.Width]);
    pix^:=Max((pix^ and $F800) shr 11, Color)*2048
         +Max((pix^ and $7E0) shr 6, Color)*64
         +Max(pix^ and $1F, Color);
  end;
  RePaintMap:=true;
end;

procedure CreateBases;
var
  i, j:Integer;
  nor, num, nlm:Integer;
  dstor, dstum, dstlm:Single;
  Defd:Array[1..BASES] of Boolean;
label
  no, no2, no3, no4;
begin
  Randomize;
  for i:=1 to BASES div 2 do begin
    with Base[i] do begin
      no:
      X:=10+Random(236);
      Y:=10+Random(236);
      if X+Y<256 then goto no;
      for j:=1 to i-1 do begin
        if (abs(Base[i].X-Base[j].X)<6)and(abs(Base[i].Y-Base[j].Y)<12) then goto no;
      end;
      MoveTo:=i;
      Owner:=1;
      Attacked:=False;
      Battle:=False;
      Defend.Fighters:=2;
      for j:=1 to RACES do begin
        with Troops.Race[j] do begin
          Fighters:=0;
          Bombers:=0;
          Destroyers:=0;
        end;
        with Coming.Race[j] do begin
          Fighters:=0;
          Bombers:=0;
          Destroyers:=0;
        end;
      end;
      with Troops.Race[1] do begin
        Fighters:=5;
        Bombers:=0;
        Destroyers:=0;
      end;
    end;
  end;
  for i:=BASES div 2+1 to BASES do begin
    with Base[i] do begin
      no2:
      X:=10+Random(236);
      Y:=10+Random(236);
      if X+Y>256 then goto no2;
      for j:=1 to i-1 do begin
        if (abs(Base[i].X-Base[j].X)<6)and(abs(Base[i].Y-Base[j].Y)<12) then goto no2;
      end;
      MoveTo:=i;
      Owner:=2;
      Attacked:=False;
      Battle:=False;
      Defend.Fighters:=1;
      for j:=1 to RACES do begin
        with Troops.Race[j] do begin
          Fighters:=0;
          Bombers:=0;
          Destroyers:=0;
        end;
        with Coming.Race[j] do begin
          Fighters:=0;
          Bombers:=0;
          Destroyers:=0;
        end;
      end;
      with Troops.Race[2] do begin
        Fighters:=5;
        Bombers:=0;
        Destroyers:=0;
      end;
    end;
  end;
  for i:=1 to BASES do begin
    if Random(20)=0 then Base[i].Troops.Race[Base[i].Owner].Bombers:=1;
    if Random(20)=0 then Base[i].Troops.Race[Base[i].Owner].Destroyers:=1;
  end;
  for i:=1 to BASES do Defd[i]:=False;
  nor:=1;
  num:=2;
  nlm:=3;
  for j:=1 to NUMREINFBASES do begin
    dstor:=1E40;
    dstum:=1E40;
    dstlm:=1E40;
    for i:=1 to BASES do begin
      with Base[i] do begin
        if (Y-X<dstor)and(not Defd[i]) then begin
          nor:=i;
          dstor:=Y-X;
        end;
      end;
    end;
    Defd[nor]:=True;
    ReInfBases.Race[3].Base[j]:=nor;
    for i:=1 to BASES do begin
      with Base[i] do begin
        if (sqrt((X-128)*(X-128)+(Y-256)*(Y-256))<dstum)and(not Defd[i]) then begin
          num:=i;
          dstum:=sqrt((X-128)*(X-128)+(Y-256)*(Y-256));
        end;
      end;
    end;
    Defd[num]:=True;
    ReInfBases.Race[1].Base[j]:=num;
    for i:=1 to BASES do begin
      with Base[i] do begin
        if (sqrt((X-0)*(X-0)+(Y-128)*(Y-128))<dstlm)and(not Defd[i]) then begin
          nlm:=i;
          dstlm:=sqrt((X-0)*(X-0)+(Y-128)*(Y-128));
        end;
      end;
    end;
    Defd[nlm]:=True;
    ReInfBases.Race[2].Base[j]:=nlm;
  end;
{  for i:=BASES-2 to BASES do begin
    with Base[i] do begin
      no3:
      X:=10+Random(236);
      Y:=10+Random(236);
      if (X-Y<200) then goto no3;
      for j:=1 to i-1 do begin
        if (abs(Base[i].X-Base[j].X)<8)and(abs(Base[i].Y-Base[j].Y)<15) then goto no3;
      end;
      Owner:=3;
      with Troops.Race[3] do begin
        Fighters:=MAXBASEFIGHTERS;
        Bombers:=MAXBASEBOMBERS;
        Destroyers:=MAXBASEDESTROYERS;
      end;
    end;
  end;}
  NSel:=1;
{  for i:=1 to BASES do begin
    with Base[i] do begin
      no:
      X:=10+Random(236);
      Y:=10+Random(236);
      if X+Y>256 then begin
        Owner:=1;
        NSel:=i;
      end else Owner:=2;
      MoveTo:=i;
      if i>1 then
        for j:=1 to i-1 do begin
          if (Abs(X-Base[j].X)<10)and(Abs(Y-Base[j].Y)<10) then goto no;
        end;
    end;
  end;
  for j:=1 to 3 do begin
    tmp:=-1;
    n:=1;
    for i:=1 to BASES do begin
      with Base[i] do begin
        if (X+(256-Y)>tmp)and(Base[i].Owner<>3) then begin
          tmp:=Trunc(X+(256-Y));
          n:=i;
        end;
      end;
    end;
    Base[N].Owner:=3;
  end;
  for i:=1 to BASES do begin
    with Base[i] do begin
      for j:=1 to RACES do begin
        Troops.Race[j].Fighters:=0;
        Troops.Race[j].Bombers:=0;
        Troops.Race[j].Destroyers:=0;
      end;
      if Owner=3 then begin
        Troops.Race[Owner].Fighters:=MAXBASEFIGHTERS;
        Troops.Race[Owner].Bombers:=MAXBASEBOMBERS;
        Troops.Race[Owner].Destroyers:=MAXBASEDESTROYERS;
        Defend.Fighters:=1;
      end else begin
        Troops.Race[Owner].Fighters:=5;
        Defend.Fighters:=1;
      end;
    end;
  end;
  while Base[NSel].Owner<>1 do NSel:=1+Random(BASES);}
end;

procedure CheckBaseInfo;
begin
  Form7.Available1.Caption:=
  'Blue:    '+IntToStr(Base[NSel].Troops.Race[1].Fighters)+'+'+IntToStr(Base[NSel].Coming.Race[1].Fighters)+' Fighter(s), '
            +IntToStr(Base[NSel].Troops.Race[1].Bombers)+'+'+IntToStr(Base[NSel].Coming.Race[1].Bombers)+' Bomber(s), '
            +IntToStr(Base[NSel].Troops.Race[1].Destroyers)+'+'+IntToStr(Base[NSel].Coming.Race[1].Destroyers)+' Destroyer(s)';
  Form7.Available2.Caption:=
  'Red:    '+IntToStr(Base[NSel].Troops.Race[2].Fighters)+'+'+IntToStr(Base[NSel].Coming.Race[2].Fighters)+' Fighter(s), '
            +IntToStr(Base[NSel].Troops.Race[2].Bombers)+'+'+IntToStr(Base[NSel].Coming.Race[2].Bombers)+' Bomber(s), '
            +IntToStr(Base[NSel].Troops.Race[2].Destroyers)+'+'+IntToStr(Base[NSel].Coming.Race[2].Destroyers)+' Destroyer(s)';
  Form7.Available3.Caption:=
  'Green: '+IntToStr(Base[NSel].Troops.Race[3].Fighters)+'+'+IntToStr(Base[NSel].Coming.Race[3].Fighters)+' Fighter(s), '
           +IntToStr(Base[NSel].Troops.Race[3].Bombers)+'+'+IntToStr(Base[NSel].Coming.Race[3].Bombers)+' Bomber(s), '
           +IntToStr(Base[NSel].Troops.Race[3].Destroyers)+'+'+IntToStr(Base[NSel].Coming.Race[3].Destroyers)+' Destroyer(s)';
  Form7.NumDFighters.Position:=Base[NSel].Defend.Fighters;
  Form7.NumDBombers.Position:=Base[NSel].Defend.Bombers;
  Form7.NumDDestroyers.Position:=Base[NSel].Defend.Destroyers;
  with Base[NSel].Troops.Race[1] do begin
    if not NumSelected then begin
      Form7.NumSFighters.Position:=Fighters-Base[NSel].Defend.Fighters;
      Form7.NumSBombers.Position:=Bombers-Base[NSel].Defend.Bombers;
      Form7.NumSDestroyers.Position:=Destroyers-Base[NSel].Defend.Destroyers;
    end;
  end;
end;

procedure InitGame;
var
  Re:PReInf;
begin
  GameMode:=1;
  GameTime:=0;
  InitStars;
  New(Reinforcements);
  Reinforcements.Troops.Fighters:=MAXBASEFIGHTERS*20;
  Reinforcements.Troops.Bombers:=MAXBASEBOMBERS*20;
  Reinforcements.Troops.Destroyers:=MAXBASEDESTROYERS*20;
  Reinforcements.Done:=False;
  Reinforcements.StoryID:=2;
  Reinforcements.Time:=600;
  Reinforcements.Race:=3;
  Reinforcements.Next:=nil;
  New(Re);
  Re.Troops.Fighters:=MAXBASEFIGHTERS*0;
  Re.Troops.Bombers:=MAXBASEBOMBERS*0;
  Re.Troops.Destroyers:=MAXBASEDESTROYERS*0;
  Re.Done:=False;
  Re.StoryID:=3;
  Re.Time:=1000;
  Re.Race:=1;
  Re.Next:=Reinforcements;
  Reinforcements:=Re;
  New(Re);
  Re.Troops.Fighters:=MAXBASEFIGHTERS*20;
  Re.Troops.Bombers:=MAXBASEBOMBERS*20;
  Re.Troops.Destroyers:=MAXBASEDESTROYERS*20;
  Re.Done:=False;
  Re.StoryID:=4;
  Re.Time:=1200;
  Re.Race:=1;
  Re.Next:=Reinforcements;
  Reinforcements:=Re;
  New(Re);
  Re.Troops.Fighters:=MAXBASEFIGHTERS*20;
  Re.Troops.Bombers:=MAXBASEBOMBERS*20;
  Re.Troops.Destroyers:=MAXBASEDESTROYERS*20;
  Re.Done:=False;
  Re.StoryID:=0;
  Re.Time:=1200;
  Re.Race:=2;
  Re.Next:=Reinforcements;
  Reinforcements:=Re;
  New(Re);
  Re.Troops.Fighters:=MAXBASEFIGHTERS*10;
  Re.Troops.Bombers:=MAXBASEBOMBERS*10;
  Re.Troops.Destroyers:=MAXBASEDESTROYERS*10;
  Re.Done:=False;
  Re.StoryID:=5;
  Re.Time:=1600;
  Re.Race:=3;
  Re.Next:=Reinforcements;
  Reinforcements:=Re;
  CreateBases;
  Randomize;
  MyRandSeed:=Random(30000);
  CreateNebulaMap(MyRandSeed);
  CheckBaseInfo;
  PlayTheme(False);
end;

procedure DoReInitGame;
var
  i:Integer;
  Re:PReInf;
begin
  for i:=1 to GROUPS do begin
    Group[i].Used:=False;
  end;
  while Reinforcements<>nil do begin
    Re:=Reinforcements;
    Reinforcements:=Reinforcements.Next;
    Dispose(Re);
  end;
  for i:=1 to RACEs do begin
    LastKIOrder[i]:=0;
    KIOrdersLeft[i]:=KIORDERNUM;
  end;
  LastCReInfTime:=0;
  LastSmokeTime:=0;
  CalcBaseTime:=0;
  CalcTargetTime:=0;
  InitGame;
  ReInitGame:=False;
  ReInitOffscreen:=True;
end;

procedure InitIntro;
begin
  New(BView.BShips);
  with BView.BShips^ do begin
    with Graphic do begin
      X:=0;
      Y:=0;
      Z:=128;
      Yaw:=0;
      Roll:=0;
      Pitch:=0;
      dYaw:=0;
      dYawf:=0;
      Speed:=0;
      VO:=TVoxelObj.Create;
      VO.Load('Data\Objects\Vulture.vox');
    end;
    Next:=nil;
    Typ:=1;
    Race:=2;
    KI.State:=30;
  end;
  View.Zoom:=1;
  View.X:=0;
  View.Y:=0;
end;

procedure Init;
begin
  Form5.ProgressBar1.Position:=5;
  Form5.Label2.Caption:='5%';
  HelpMsg:='Click a base, press the "m" key and click a target base to move ships';
  LastTm:=TimeStampToMSecs(DateTimeToTimeStamp(Time));
  Form5.ProgressBar1.Position:=15;
  Form5.Label2.Caption:='15%';
  ReInitOffscreen:=False;
  RepaintMap:=False;
  Offscreen:=TBitmap.Create;
  Offscreen.Width:=Form1.ClientWidth;
  Offscreen.Height:=Form1.ClientHeight;
  Offscreen.PixelFormat:=pf16bit;
  Offscreen.HandleType:=bmDIB;
  SWidth:=Offscreen.Width;
  SHeight:=Offscreen.Height;
  Form5.ProgressBar1.Position:=25;
  Form5.Label2.Caption:='25%';
  pl:=Offscreen.Scanline[0];
  Form5.ProgressBar1.Position:=30;
  Form5.Label2.Caption:='30%';
  Form5.ProgressBar1.Position:=50;
  Form5.Label2.Caption:='50%';
  PreCalcSineTables;
  Form5.ProgressBar1.Position:=60;
  Form5.Label2.Caption:='60%';
  Form5.ProgressBar1.Position:=70;
  Form5.Label2.Caption:='70%';
  GameMode:=4;
  Form5.ProgressBar1.Position:=95;
  Form5.Label2.Caption:='95%';
  InitIntro;
end;

procedure Line(X1, Y1, X2, Y2:Integer;Color:Word;pl:ppixline;SWidth, SHeight:Integer);
var
  I, X, Y:integer;
begin
  if Abs(X1-X2)>Abs(Y1-Y2) then begin
    if X1<>X2 then
    for i:=Min(X1, X2) to Max(X1, X2) do begin
      X:=i;
      Y:=Trunc(Y1+(i-X1)/(X2-X1)*(Y2-Y1));
      if (X>=0)and(X<SWidth)and(Y>=0)and(Y<SHeight) then pl^[X-Y*SWidth]:=Color;
    end;
  end else begin
    if Y1<>Y2 then
    for i:=Min(Y1, Y2) to Max(Y1, Y2) do begin
      X:=Trunc(X1+(i-Y1)/(Y2-Y1)*(X2-X1));
      Y:=i;
      if (X>=0)and(X<SWidth)and(Y>=0)and(Y<SHeight) then pl^[X-Y*SWidth]:=Color;
    end;
  end;
end;

procedure DoRepaintMap;
type
  OpenInt=Array [0..65535] of Integer;
var
  i, j, k, l:Integer;
  pl2, pn:ppixline;
  NWidth, NHeight:Integer;
  Color:Word;
  WF, HF:Single;
  YS:Integer;
  XRel:^OpenInt;
  This:PBattle;
begin
  if BLOCKTIMING then StartTimer(3);
//  if DEBUG then DebugNum(30);
  WF:=SWidth/256;
  HF:=SHeight/256;
  pl2:=pl;
{  for i:=0 to NebulaMap.SHeight do begin
    Move(NebulaMap.Scanline[i]^, Offscreen.Scanline[i]^, 256*2);
  end;}
//  NebulaOff.IgnorePalette:=True;
  pn:=NebulaMap.Scanline[0];
  NWidth:=NebulaMap.Width;
  NHeight:=NebulaMap.Height;
//  if DEBUG then DebugNum(31);
//  Buf:=NebulaMap;
//  Offscreen.Canvas.StretchDraw(Offscreen.Canvas.ClipRect, NebulaMap);
  GetMem(XRel, SWidth*SizeOf(Integer));
  for i:=0 to SWidth-1 do begin
    XRel^[i]:=i*(NWidth-1) div SWidth;
  end;
  for j:=0 to SHeight-1 do begin
    YS:=-(j*(NHeight-1) div SHeight)*NWidth;
    for i:=0 to SWidth-1 do begin
      pl^[i-j*SWidth]:=pn^[XRel^[i]+YS];
    end;
  end;
  FreeMem(XRel, SWidth*SizeOf(Integer));
  if BLOCKTIMING then StopTimer(3);
  Timing(True);
  if BLOCKTIMING then StartTimer(4);
  if GameTime>100 then HelpMsg:='';
  Offscreen.Canvas.Font.Color:=clWhite;
  Offscreen.Canvas.TextOut(20, Form1.ClientHeight-40, HelpMsg);
//  if DEBUG then DebugNum(32);
//  NebulaMap.ReleasePalette;
//  NebulaOff.Assign(NebulaMap);
  Color:=0;
  This:=Battles;
  while This<>nil do begin
    for k:=Trunc(Base[This.Base].X*WF)-4 to Trunc(Base[This.Base].X*WF)+4 do begin
      for l:=Trunc(Base[This.Base].Y*HF)-4 to Trunc(Base[This.Base].Y*HF)+4 do begin
        pl2^[k-l*SWidth]:=Trunc(31*(0.5+0.5*SinT[(cnt*8) and 255]))*($840);
      end;
    end;
    if GameTime<100 then HelpMsg:='Doubleclick a yellow highlighted base to enter battle mode';
    This:=This.Next;
  end;
//  if DEBUG then DebugNum(33);
  if Form1.ShowBases.Checked then
    for i:=1 to BASES do begin
{      If (Base[i].Attacked)and(not Base[i].Battle) Then begin
        for k:=Trunc(Base[i].X*WF)-4 to Trunc(Base[i].X*WF)+4 do begin
          for l:=Trunc(Base[i].Y*HF)-4 to Trunc(Base[i].Y*HF)+4 do begin
            pl2^[k-l*SWidth]:=$C600;
          end;
        end;
      end;}
      if (i=NSel) then begin
        for k:=Trunc(Base[i].X*WF)-3 to Trunc(Base[i].X*WF)+3 do begin
          for l:=Trunc(Base[i].Y*HF)-3 to Trunc(Base[i].Y*HF)+3 do begin
            pl2^[k-l*SWidth]:=$FFFF;
          end;
        end;
      end;
      case Base[i].Owner of
        1:Color:=$007F;
        2:Color:=$F800;
        3:Color:=$780;
      end;
      for k:=Trunc(Base[i].X*WF)-2 to Trunc(Base[i].X*WF)+2 do begin
        for l:=Trunc(Base[i].Y*HF)-2 to Trunc(Base[i].Y*HF)+2 do begin
          pl2^[k-l*SWidth]:=Color;
        end;
      end;
    end;
//  if DEBUG then DebugNum(34);
  if Form1.ShowTactics.Checked then begin
    for i:=1 to BASES do begin
      with Base[i] do begin
        if Owner=1 then begin
          if (MoveTo<>0)and(MoveTo<>i) then begin
            case Owner of
              1:Color:=$F;
              2:Color:=$7800;
              3:Color:=$3E0;
            end;
            Line(Trunc(X*WF), Trunc(Y*HF), Trunc(Base[MoveTo].X*WF), Trunc(Base[MoveTo].Y*HF), Color, pl2, SWidth, SHeight);
          end;
        end;
      end;
    end;
  end;
//  if DEBUG then DebugNum(35);
  if Form1.ShowTroops.Checked then begin
    for i:=1 to BASES do begin
      for j:=1 to RACES do begin
        with Base[i].Troops.Race[j] do begin
          if Fighters>0 then begin
            case j of
              1:Color:=$007F;
              2:Color:=$F800;
              3:Color:=$780;
            end;
            for k:=Trunc(Base[i].X*WF)-11+j*2 to Trunc(Base[i].X*WF)-10+j*2 do begin
              for l:=Trunc(Base[i].Y*HF)-5-Fighters to Trunc(Base[i].Y*HF)-5 do begin
                pl2^[k-l*SWidth]:=Color;
              end;
            end;
          end;
          if Bombers>0 then begin
            case j of
              1:Color:=$007F;
              2:Color:=$F800;
              3:Color:=$780;
            end;
            for k:=Trunc(Base[i].X*WF)-4+j*2 to Trunc(Base[i].X*WF)-3+j*2 do begin
              for l:=Trunc(Base[i].Y*HF)-5-Bombers to Trunc(Base[i].Y*HF)-5 do begin
                pl2^[k-l*SWidth]:=Color;
              end;
            end;
          end;
          if Destroyers>0 then begin
            case j of
              1:Color:=$007F;
              2:Color:=$F800;
              3:Color:=$780;
            end;
            for k:=Trunc(Base[i].X*WF)+3+j*2 to Trunc(Base[i].X*WF)+4+j*2 do begin
              for l:=Trunc(Base[i].Y*HF)-5-Destroyers to Trunc(Base[i].Y*HF)-5 do begin
                pl2^[k-l*SWidth]:=Color;
              end;
            end;
          end;
        end;
      end;
    end;
//    if DEBUG then DebugNum(36);
    for i:=1 to GROUPS do begin
      with Group[i] do begin
        if Used then begin
          case Owner of
            1:Color:=$7F;
            2:Color:=$F800;
            3:Color:=$780;
          end;
          for k:=Trunc(X*WF)-1 to Trunc(X*WF)+1 do begin
            if (k>=0)and(k<SWidth) then begin
              for l:=Trunc(Y*HF)-1 to Trunc(Y*HF)+1 do begin
                if (l>=0)and(l<SHeight) then pl2^[k-l*SWidth]:=Color;
              end;
            end;
          end;
          case Owner of
            1:Color:=$7F;
            2:Color:=$F800;
            3:Color:=$780;
          end;
          Line(Trunc(X*WF), Trunc(Y*HF), Trunc(Base[Dest].X*WF), Trunc(Base[Dest].Y*HF), Color, pl2, SWidth, SHeight);
        end;
      end;
    end;
  end;
//  if DEBUG then DebugNum(37);
//  Form1.Image1.Picture.Bitmap.Canvas.Draw(0, 0, NebulaOff);
//  Form1.Image1.Picture.Assign(NebulaOff);
  RepaintMap:=False;
  if BLOCKTIMING then StopTimer(4);
end;

procedure Explode(NShip:PBShip; Wave:Boolean);
var
  Srch:PBShip;
  i, j:Integer;
  a:Byte;
begin
  if DEBUG then DebugNum(58);
  // Sound
  {if NShip.KI.State<>10 then begin
    PlaySound(1, 'expl.mid', True);
  end;}
  // Smoke
  for i:=1 to SMOKESPOTS div 20 do begin
    j:=1+Random(SMOKESPOTS);
    with Smoke[j] do begin
      Used:=True;
      a:=Random(256);
      X:=NShip.Graphic.X-Random(20)*SinT[a];
      Y:=NShip.Graphic.Y-Random(20)*CosT[a];
      SpeedX:=0;
      SpeedY:=0;
      Z:=128;
      Timer:=300+Random(300);
      Color:=16+Random(16);
      Color:=Color shl 11+Random(Color) shl 6;
    end;
  end;
  if Wave then begin
    for i:=1 to SMOKESPOTS div 5 do begin
      j:=1+Random(SMOKESPOTS);
      with Smoke[j] do begin
        Used:=True;
        X:=NShip.Graphic.X;
        Y:=NShip.Graphic.Y;
        a:=Random(256);
        SpeedX:=100*SinT[a];
        SpeedY:=100*CosT[a];
        Z:=128;
        Timer:=300+Random(300);
        Color:=$3F;
      end;
    end;
  end;
  // KI
  if NShip.Target<>nil then Dec(NShip.Target.KI.Attackedby);
  // check if targeted
  Srch:=BView.BShips;
  while Srch<>nil do begin
    if Srch.Target=NShip then Srch.Target:=nil;
    Srch:=Srch.Next;
  end;
  // update Battle
  if Wave then begin
    case NShip.Typ of
      1:Dec(Base[BView.Base].Troops.Race[NShip.Race].Fighters);
      2:Dec(Base[BView.Base].Troops.Race[NShip.Race].Bombers);
      3:Dec(Base[BView.Base].Troops.Race[NShip.Race].Destroyers);
    end;
  end;
  // Remove Ship
  if NShip=BView.BShips then begin
    BView.BShips:=NShip.Next;
    Dispose(NShip);
  end else begin
    Srch:=BView.BShips;
    while Srch.Next<>NShip do Srch:=Srch.Next;
    Srch.Next:=NShip.Next;
    Dispose(NShip);
  end;
end;

procedure JumpOut(NShip:PBShip);
var
  i, j:Integer;
  a:Byte;
  NVs:PViewSpot;
begin
  for i:=1 to SMOKESPOTS div 6 do begin
    j:=1+Random(SMOKESPOTS);
    with Smoke[j] do begin
      Used:=True;
      a:=Random(256);
      X:=NShip.Graphic.X;
      Y:=NShip.Graphic.Y;
      SpeedX:=100*(CosT[a]*CosT[Trunc(NShip.Graphic.Yaw)and 255]
                  -SinT[a]*SinT[Trunc(NShip.Graphic.Yaw)and 255]*0.1);
      SpeedY:=100*(SinT[a]*CosT[Trunc(NShip.Graphic.Yaw)and 255]*0.1
                  +CosT[a]*SinT[Trunc(NShip.Graphic.Yaw)and 255]);
      Z:=128;
      Timer:=300+Random(300);
      Color:=$3E;
    end;
  end;
  New(NVs);
  NVs.X:=NShip.Graphic.X;
  NVs.Y:=NShip.Graphic.Y;
  NVs.Timer:=2;
  NVs.Next:=BView.ViewSpots;
  BView.ViewSpots:=NVs;
end;

procedure DrawVGraphics;
var
{  i, j:Integer;
  X, Y:Single;}
  BShp, Tmp:PBShip;
  Color:Word;
begin
  BShp:=BView.BShips;
  while BShp<>nil do begin
    if (BShp.KI.State=10)and(GameTime-BShp.KI.Since>=2) then begin
      Tmp:=BShp.Next;
      JumpOut(BShp);
      Explode(BShp, False);
      BShp:=Tmp;
      continue;
    end;
    if BShp.KI.State=10 then DrawVoxObj(BShp^.Graphic, Trunc(BShp^.Graphic.VO.Anz*(2-(GameTime-BShp.KI.Since))/2))
    else if BShp.KI.State=40 then DrawVoxObj(BShp^.Graphic, Trunc(BShp^.Graphic.VO.Anz*(GameTime-BShp.KI.Since)/2))
    else begin
      DrawVoxObj(BShp^.Graphic, BShp^.Graphic.VO.Anz);
      if (BShp.Typ=BView.STypSel)and(BShp.Race=1) then begin
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X-15+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X+15+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X+25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+25+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X-15+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+25+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X+15+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+25+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X+25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+25+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-15+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+15+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+25+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X+25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X+25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-15+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X+25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+15+View.Y)*View.Zoom)
           , SWidth  shr 1+Trunc((BShp.Graphic.X+25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y+25+View.Y)*View.Zoom), $FFFF, pl, SWidth, SHeight);
      end;
      if GameMode=2 then begin
        Color:=$0740;
        if BShp.Hitp<66 then Color:=$FF40;
        if BShp.Hitp<33 then Color:=$F800;
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)-3
           , SWidth  shr 1+Trunc((BShp.Graphic.X-25+0.5*BShp.Hitp+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)-3, Color, pl, SWidth, SHeight);
        Line(SWidth  shr 1+Trunc((BShp.Graphic.X-25+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)-4
           , SWidth  shr 1+Trunc((BShp.Graphic.X-25+0.5*BShp.Hitp+View.X)*View.Zoom)
           , SHeight shr 1+Trunc((BShp.Graphic.Y-25+View.Y)*View.Zoom)-4, Color, pl, SWidth, SHeight);
      end;
    end;
{    BShp^.Graphic.Yaw:=BShp^.Graphic.Yaw+1;
    BShp^.Graphic.Pitch:=BShp^.Graphic.Pitch+2;
    BShp^.Graphic.Roll:=BShp^.Graphic.Roll+3;}
    BShp:=BShp.Next;
  end;
end;

procedure DoMoveOnce(From, Two, Fig, Bom, Des:Integer);
var
  i:Integer;
  NumF, NumB, NumD:Integer;
  FTo, FCo:^TRTroops;
begin
  with Base[From], Base[From].Troops.Race[Owner] do begin
    NumF:=Fig;
    NumB:=Bom;
    NumD:=Des;
    FTo:=Addr(Base[Two].Troops.Race[Owner]);
    FCo:=Addr(Base[Two].Coming.Race[Owner]);
    while FTo^.Fighters+FCo^.Fighters+NumF>MAXBASEFIGHTERS do Dec(NumF);
    while FTo^.Bombers+FCo^.Bombers+NumB>MAXBASEBOMBERS do Dec(NumB);
    while FTo^.Destroyers+FCo^.Destroyers+NumD>MAXBASEDESTROYERS do Dec(NumD);
    if (NumF<=0)and(NumB<=0)and(NumD<=0) then exit;
    for i:=1 to GROUPS do begin
      With Group[i] do begin
        if not Used then begin
          Inc(FCo^.Fighters, NumF);
          Inc(FCo^.Bombers, NumB);
          Inc(FCo^.Destroyers, NumD);
          Owner:=Base[From].Owner;
          Troops.Fighters:=NumF;
          Dec(Base[From].Troops.Race[Owner].Fighters, NumF);
          Troops.Bombers:=NumB;
          Dec(Base[From].Troops.Race[Owner].Bombers, NumB);
          Troops.Destroyers:=NumD;
          Dec(Base[From].Troops.Race[Owner].Destroyers, NumD);
          if (GameMode=2)and(From=BView.Base) then BRemove(Owner, NumF, NumB, NumD);
          X:=Base[From].X;
          Y:=Base[From].Y;
          Dest:=Two;
          RepaintMap:=True;
          Used:=True;
          break;
        end;
      end;
    end;
  end;
end;

procedure Reinforce(Race, FromX, FromY, Two, Fig, Bom, Des:Integer);
var
  i:Integer;
  NumF, NumB, NumD:Integer;
  FTo, FCo:^TRTroops;
begin
  NumF:=Fig;
  NumB:=Bom;
  NumD:=Des;
  FTo:=Addr(Base[Two].Troops.Race[Race]);
  FCo:=Addr(Base[Two].Coming.Race[Race]);
  while FTo^.Fighters+FCo^.Fighters+NumF>MAXBASEFIGHTERS do Dec(NumF);
  while FTo^.Bombers+FCo^.Bombers+NumB>MAXBASEBOMBERS do Dec(NumB);
  while FTo^.Destroyers+FCo^.Destroyers+NumD>MAXBASEDESTROYERS do Dec(NumD);
  if (NumF<=0)and(NumB<=0)and(NumD<=0) then exit;
  for i:=1 to GROUPS do begin
    With Group[i] do begin
      if not Used then begin
        Inc(FCo^.Fighters, NumF);
        Inc(FCo^.Bombers, NumB);
        Inc(FCo^.Destroyers, NumD);
        Owner:=Race;
        Troops.Fighters:=NumF;
        Troops.Bombers:=NumB;
        Troops.Destroyers:=NumD;
        X:=FromX;
        Y:=FromY;
        Dest:=Two;
        RepaintMap:=True;
        Used:=True;
        break;
      end;
    end;
  end;
end;

procedure DoLeaveBattle;
var
  NShip:PBShip;
  NShot:PShot;
  NViewSpot:PViewSpot;
begin
  GameMode:=1;
  Form1.SetMode1.Caption:='To Battle';
  Form2.Hide;
  if Form1.Orders1.Checked then Form7.Show;
  Form1.ShowBases.Enabled:=True;
  Form1.ShowTroops.Enabled:=True;
  Form1.ShowTactics.Enabled:=True;
  while BView.BShips<>nil do begin
    NShip:=BView.BShips;
    BView.BShips:=BView.BShips.Next;
    Dispose(NShip);
  end;
  while BView.Shots<>nil do begin
    NShot:=BView.Shots;
    BView.Shots:=BView.Shots.Next;
    Dispose(NShot);
  end;
  while BView.ViewSpots<>nil do begin
    NViewSpot:=BView.ViewSpots;
    BView.ViewSpots:=BView.ViewSpots.Next;
    Dispose(NViewSpot);
  end;
  LeaveBattle:=False;
end;

procedure InitCredits;
begin
  Credits.Time:=0;
  Credits.LastBird:=0;
  //PlaySound(1, 'Elise.mid', True);
end;

procedure DoEnterBattle;
var
  i, j:Integer;
  NShip:PBShip;
  FAll, FDone:Integer;
begin
  Form5.Show;
  Form5.Label1.Caption:='Loading Battle...';
  Form5.ProgressBar1.Position:=0;
  Form5.Label2.Caption:='0%';
  GameMode:=2;
  Form1.SetMode1.Caption:='To Tactics Map';
  Form7.Hide;
  Form1.Orders1.Checked := false;
//  if Form1.Orders1.Checked then Form2.Show;
//  Form2.Hide;
  Form1.ShowBases.Enabled:=False;
  Form1.ShowTroops.Enabled:=False;
  Form1.ShowTactics.Enabled:=False;
  View.X:=0;
  View.Y:=0;
  View.Zoom:=1;
  View.dX:=0;
  View.dY:=0;
  View.dZoom:=1;
  BView.Base:=NSel;
  BView.BShips:=nil;
  BView.Shots:=nil;
  BView.STypSel:=0;
  BView.ViewSpots:=nil;
  for i:=1 to RACES do begin
    for j:=1 to 3 do begin
      BView.BGroupKI.Race[i].Target[i].Race:=0;
      BView.BGroupKI.Race[i].Target[i].Typ:=0;
    end;
  end;
  FAll:=0;
  FDone:=0;
  for i:=1 to RACES do begin
    Inc(FAll,Base[BView.Base].Troops.Race[i].Fighters);
    Inc(FAll,Base[BView.Base].Troops.Race[i].Bombers);
    Inc(FAll,Base[BView.Base].Troops.Race[i].Destroyers);
  end;
  for i:=1 to RACES do begin
    if Base[NSel].Troops.Race[i].Fighters>0 then
      for j:=1 to Base[NSel].Troops.Race[i].Fighters do begin
        New(NShip);
        NShip.Race:=i;
        NShip.Typ:=1;
        NShip.ID:=j;
        NShip.Graphic.VO:=TVoxelObj.Create;
        case i of
          1:NShip.Graphic.VO.Load('Data\Objects\Raptor.vox');
          2:NShip.Graphic.VO.Load('Data\Objects\Vulture.vox');
          3:NShip.Graphic.VO.Load('Data\Objects\Fighter.vox');
        end;
        NShip.Next:=BView.BShips;
        BView.BShips:=NShip;
        Inc(FDone);
        Form5.ProgressBar1.Position:=Trunc(100*FDone/FAll);
        Form5.Label2.Caption:=InttoStr(Trunc(100*FDone/FAll))+'%';
      end;
    if Base[NSel].Troops.Race[i].Bombers>0 then
      for j:=1 to Base[NSel].Troops.Race[i].Bombers do begin
        New(NShip);
        NShip.Race:=i;
        NShip.Typ:=2;
        NShip.ID:=j;
        NShip.Graphic.VO:=TVoxelObj.Create;
        case i of
          1:NShip.Graphic.VO.Load('Data\Objects\Patriot.vox');
          2:NShip.Graphic.VO.Load('Data\Objects\Bomber.vox');
          3:NShip.Graphic.VO.Load('Data\Objects\Tie.vox');
        end;
        NShip.Next:=BView.BShips;
        BView.BShips:=NShip;
        Inc(FDone);
        Form5.ProgressBar1.Position:=Trunc(100*FDone/FAll);
        Form5.Label2.Caption:=InttoStr(Trunc(100*FDone/FAll))+'%';
      end;
    if Base[NSel].Troops.Race[i].Destroyers>0 then
      for j:=1 to Base[NSel].Troops.Race[i].Destroyers do begin
        New(NShip);
        NShip.Race:=i;
        NShip.Typ:=3;
        NShip.ID:=j;
        NShip.Graphic.VO:=TVoxelObj.Create;
        case i of
          1:NShip.Graphic.VO.Load('Data\Objects\Luna.vox');
          2:NShip.Graphic.VO.Load('Data\Objects\Mars.vox');
          3:NShip.Graphic.VO.Load('Data\Objects\Destroyer.vox');
        end;
        NShip.Next:=BView.BShips;
        BView.BShips:=NShip;
        Inc(FDone);
        Form5.ProgressBar1.Position:=Trunc(100*FDone/FAll);
        Form5.Label2.Caption:=InttoStr(Trunc(100*FDone/FAll))+'%';
      end;
  end;
  NShip:=BView.BShips;
  while NShip<>nil do begin
    NShip.Hitp:=100;
    case NShip.Race of
      1:begin
          NShip.Graphic.X:=-300+50*NShip.ID;
          NShip.Graphic.Y:=0+50*NShip.Typ-20*NShip.ID;
          NShip.Graphic.Yaw:=0;
        end;
      2:begin
          NShip.Graphic.X:=-300+50*NShip.ID;
          NShip.Graphic.Y:=-1000-50*NShip.Typ+20*NShip.ID;
          NShip.Graphic.Yaw:=128;
        end;
      3:begin
          NShip.Graphic.X:=600+50*NShip.Typ;
          NShip.Graphic.Y:=-600+50*NShip.ID;
          NShip.Graphic.Yaw:=192;
        end;
    end;
    NShip.Graphic.Z:=128;
    NShip.Graphic.Pitch:=0;
    NShip.Graphic.Roll:=128;
    NShip.Graphic.dYaw:=0;
    NShip.Graphic.dYawf:=0;
    NShip.Graphic.Speed:=0;
    NShip.Graphic.dYawv:=0;
    NShip.Graphic.CreateBuf:=False;
    NShip.Ki.State:=0;
    NShip.Ki.Since:=0;
    NShip.Ki.AttackedBy:=0;
    NShip.LastShot:=0;
    NShip.Target:=nil;
    NShip.Hits.Anz:=0;
{    for i:=1 to 10 do begin
      NShip.Hits.X[i]:=-10+Random(20);
      NShip.Hits.Y[i]:=-10+Random(20);
      NShip.Hits.Y[i]:=0;
    end;}
    NShip:=NShip.Next;
  end;
  for i:=1 to SMOKESPOTS do begin
    Smoke[i].Used:=False;
  end;
  Form5.Hide;
  StopMidis;
  EnterBattle:=False;
end;

procedure BReInf(Race:Integer; Fighters, Bombers, Destroyers:Integer);
var
  i:Integer;
  NShip:PBShip;
  HighFID, HighBID, HighDID:Integer;
begin
  HighFID:=0;
  HighBID:=0;
  HighDID:=0;
  NShip:=BView.BShips;
  while NShip<>nil do begin
    if NShip.Race=Race then begin
      case NShip.Typ of
        1: HighFID:=Max(NShip.ID, HighFID);
        2: HighBID:=Max(NShip.ID, HighBID);
        3: HighDID:=Max(NShip.ID, HighDID);
      end;
    end;
    NShip:=NShip.Next;
  end;
  Inc(HighFID);
  Inc(HighBID);
  Inc(HighDID);
  if Fighters>0 then
    for i:=1 to Fighters do begin
      New(NShip);
      NShip.Race:=Race;
      NShip.Typ:=1;
      NShip.ID:=HighFID;
      Inc(HighFID);
      NShip.Graphic.VO:=TVoxelObj.Create;
      case Race of
        1:NShip.Graphic.VO.Load('Data\Objects\Raptor.vox');
        2:NShip.Graphic.VO.Load('Data\Objects\Vulture.vox');
        3:NShip.Graphic.VO.Load('Data\Objects\Fighter.vox');
      End;
      NShip.Hitp:=100;
      case NShip.Race of
        1:begin
            NShip.Graphic.X:=-300+50*NShip.ID;
            NShip.Graphic.Y:=SHeight/2/View.Zoom+50*NShip.Typ;
            NShip.Graphic.Yaw:=0;
          end;
        2:begin
            NShip.Graphic.X:=-300+50*NShip.ID;
            NShip.Graphic.Y:=-SHeight/2/View.Zoom-50*NShip.Typ;
            NShip.Graphic.Yaw:=128;
          end;
        3:begin
            NShip.Graphic.X:=SWidth/2/View.Zoom+50*NShip.Typ;
            NShip.Graphic.Y:=-600+50*NShip.ID;
            NShip.Graphic.Yaw:=192;
          end;
      end;
      NShip.Graphic.Z:=128;
      NShip.Graphic.Pitch:=0;
      NShip.Graphic.Roll:=128;
      NShip.Graphic.dYaw:=0;
      NShip.Graphic.dYawf:=0;
      NShip.Graphic.CreateBuf:=False;
      NShip.Graphic.Speed:=4*FIGHTERSPEED;
      JumpOut(NShip);
      NShip.Graphic.dYawv:=0;
      NShip.Target:=nil;
      NShip.LastShot:=0;
      NShip.Ki.State:=40;
      NShip.Ki.Since:=GameTime;
      NShip.Ki.AttackedBy:=0;
      NShip.Hits.Anz:=0;
      NShip.Next:=BView.BShips;
      BView.BShips:=NShip;
    end;
  if Bombers>0 then
    for i:=1 to Bombers do begin
      New(NShip);
      NShip.Race:=Race;
      NShip.Typ:=2;
      NShip.ID:=HighBID;
      Inc(HighBID);
      NShip.Graphic.VO:=TVoxelObj.Create;
      case NShip.Race of
        1:NShip.Graphic.VO.Load('Data\Objects\Patriot.vox');
        2:NShip.Graphic.VO.Load('Data\Objects\Bomber.vox');
        3:NShip.Graphic.VO.Load('Data\Objects\Tie.vox');
      end;
      NShip.Hitp:=100;
      case NShip.Race of
        1:begin
            NShip.Graphic.X:=-300+50*NShip.ID;
            NShip.Graphic.Y:=SHeight/2/View.Zoom+50*NShip.Typ;
            NShip.Graphic.Yaw:=0;
          end;
        2:begin
            NShip.Graphic.X:=-300+50*NShip.ID;
            NShip.Graphic.Y:=-SHeight/2/View.Zoom-50*NShip.Typ;
            NShip.Graphic.Yaw:=128;
          end;
        3:begin
            NShip.Graphic.X:=SWidth/2/View.Zoom+50*NShip.Typ;
            NShip.Graphic.Y:=-600+50*NShip.ID;
            NShip.Graphic.Yaw:=192;
          end;
      end;
      NShip.Graphic.Z:=128;
      NShip.Graphic.Pitch:=0;
      NShip.Graphic.Roll:=128;
      NShip.Graphic.dYaw:=0;
      NShip.Graphic.dYawf:=0;
      NShip.Graphic.CreateBuf:=False;
      NShip.Graphic.Speed:=4*FIGHTERSPEED;
      JumpOut(NShip);
      NShip.Graphic.dYawv:=0;
      NShip.Target:=nil;
      NShip.LastShot:=0;
      NShip.Ki.State:=40;
      NShip.Ki.Since:=GameTime;
      NShip.Ki.AttackedBy:=0;
      NShip.Hits.Anz:=0;
      NShip.Next:=BView.BShips;
      BView.BShips:=NShip;
    end;
  if Destroyers>0 then
    for i:=1 to Destroyers do begin
      New(NShip);
      NShip.Race:=Race;
      NShip.Typ:=3;
      NShip.ID:=HighDID;
      Inc(HighDID);
      NShip.Graphic.VO:=TVoxelObj.Create;
      case NShip.Race of
        1:NShip.Graphic.VO.Load('Data\Objects\Luna.vox');
        2:NShip.Graphic.VO.Load('Data\Objects\Mars.vox');
        3:NShip.Graphic.VO.Load('Data\Objects\Destroyer.vox');
      End;
      NShip.Hitp:=100;
      case NShip.Race of
        1:begin
            NShip.Graphic.X:=-300+50*NShip.ID;
            NShip.Graphic.Y:=SHeight/2/View.Zoom+50*NShip.Typ;
            NShip.Graphic.Yaw:=0;
          end;
        2:begin
            NShip.Graphic.X:=-300+50*NShip.ID;
            NShip.Graphic.Y:=-SHeight/2/View.Zoom-50*NShip.Typ;
            NShip.Graphic.Yaw:=128;
          end;
        3:begin
            NShip.Graphic.X:=SWidth/2/View.Zoom+50*NShip.Typ;
            NShip.Graphic.Y:=-600+50*NShip.ID;
            NShip.Graphic.Yaw:=192;
          end;
      end;
      NShip.Graphic.Z:=128;
      NShip.Graphic.Pitch:=0;
      NShip.Graphic.Roll:=128;
      NShip.Graphic.dYaw:=0;
      NShip.Graphic.dYawf:=0;
      NShip.Graphic.CreateBuf:=False;
      NShip.Graphic.Speed:=4*FIGHTERSPEED;
      JumpOut(NShip);
      NShip.Graphic.dYawv:=0;
      NShip.Target:=nil;
      NShip.LastShot:=0;
      NShip.Ki.State:=40;
      NShip.Ki.Since:=GameTime;
      NShip.Ki.AttackedBy:=0;
      NShip.Hits.Anz:=0;
      NShip.Next:=BView.BShips;
      BView.BShips:=NShip;
    end;
end;

procedure BRemove(Race:Integer; Fighters, Bombers, Destroyers:Integer);
var
  NF, NB, ND:Integer;
  NShip:PBShip;
begin
  NF:=Fighters;
  NB:=Bombers;
  ND:=Destroyers;
  NShip:=BView.BShips;
  while NShip<>nil do begin
    if (NF>0)and(NShip.Typ=1)and(NShip.Race=Race)and(NShip.KI.State<>10) then begin
      if NShip.KI.State=40 then
        NShip.KI.State:=41
      else
        NShip.KI.State:=10;
      NShip.KI.Since:=GameTime;
      Dec(NF);
    end;
    if (NB>0)and(NShip.Typ=2)and(NShip.Race=Race)and(NShip.KI.State<>10) then begin
      if NShip.KI.State=40 then
        NShip.KI.State:=41
      else
        NShip.KI.State:=10;
      NShip.KI.Since:=GameTime;
      Dec(NB);
    end;
    if (ND>0)and(NShip.Typ=3)and(NShip.Race=Race)and(NShip.KI.State<>10) then begin
      if NShip.KI.State=40 then
        NShip.KI.State:=41
      else
        NShip.KI.State:=10;
      NShip.KI.Since:=GameTime;
      Dec(ND);
    end;
    NShip:=NShip.Next;
  end;
end;

procedure CheckRelay(N:Integer);
begin
  if (Base[N].MoveTo<>N)and(not Base[N].Attacked)and(not Base[N].Battle) then
    DoMoveOnce(N, Base[N].MoveTo, Max(Base[n].Troops.Race[Base[N].Owner].Fighters-Base[N].Defend.Fighters, 0)
                                , Max(Base[n].Troops.Race[Base[N].Owner].Bombers-Base[N].Defend.Bombers, 0)
                                , Max(Base[n].Troops.Race[Base[N].Owner].Destroyers-Base[N].Defend.Destroyers, 0));
end;

procedure NewBattle(At:Integer);
var
  This:PBattle;
  i:Integer;
  RacesHere, Race:Integer;
begin
  New(This);
  This.Next:=Battles;
  Battles:=This;
  This.Base:=At;
  Base[At].Battle:=True;
  RacesHere:=0;
  Race:=1;
  for i:=1 to RACES do begin
    This.Hits.Race[i].Fighters:=100;
    This.Hits.Race[i].Bombers:=100;
    This.Hits.Race[i].Destroyers:=100;
    if (Base[At].Troops.Race[i].Fighters>0)
     or(Base[At].Troops.Race[i].Bombers>0)
     or(Base[At].Troops.Race[i].Destroyers>0) then begin
      Inc(RacesHere);
      Race:=i;
    end;
  end;
  if Raceshere=1 then begin
    Base[At].Troops.Race[Race].Fighters:=Max(Base[At].Troops.Race[Race].Fighters-1, 0);
    Base[At].Troops.Race[Race].Bombers:=Max(Base[At].Troops.Race[Race].Bombers-1, 0);
    Base[At].Troops.Race[Race].Destroyers:=Max(Base[At].Troops.Race[Race].Destroyers-1, 0);
  end;
end;

procedure CheckBattle(At:Integer);
var
  This:PBattle;
begin
  This:=Battles;
  while This<>nil do begin
    if This.Base=At then exit;
    This:=This.Next;
  end;
  NewBattle(At);
end;

procedure CalcBattles;
var
  This, Searcher:PBattle;
  i, j:Integer;
  Has, Have:Integer;
begin
  This:=Battles;
  while This<>nil do begin
    if (GameMode<>2)or(This.Base<>BView.Base) then begin
      Have:=0;
      Has:=Base[This.Base].Owner;
      for i:=1 to RACES do begin
        for j:=1 to RACES do begin
          if i<>j then begin
            This.Hits.Race[i].Fighters:=This.Hits.Race[i].Fighters
                                       -Base[This.Base].Troops.Race[j].Fighters*Pps*BATTLESPEED
                                       -Base[This.Base].Troops.Race[j].Destroyers*Pps*6*BATTLESPEED;
            This.Hits.Race[i].Bombers:=This.Hits.Race[i].Bombers
                                      -Base[This.Base].Troops.Race[j].Fighters*Pps*2*BATTLESPEED
                                      -Base[This.Base].Troops.Race[j].Destroyers*Pps*BATTLESPEED;
            This.Hits.Race[i].Destroyers:=This.Hits.Race[i].Destroyers
                                         -Base[This.Base].Troops.Race[j].Bombers*Pps*2*BATTLESPEED
                                         -Base[This.Base].Troops.Race[j].Fighters*Pps*0.5*BATTLESPEED
                                         -Base[This.Base].Troops.Race[j].Destroyers*Pps*0.5*BATTLESPEED;
          end;
        end;
        if This.Hits.Race[i].Fighters<0 then begin
          if Base[This.Base].Troops.Race[i].Fighters>0 then Dec(Base[This.Base].Troops.Race[i].Fighters);
          This.Hits.Race[i].Fighters:=100;
        end;
        if This.Hits.Race[i].Bombers<0 then begin
          if Base[This.Base].Troops.Race[i].Bombers>0 then Dec(Base[This.Base].Troops.Race[i].Bombers);
          This.Hits.Race[i].Bombers:=100;
        end;
        if This.Hits.Race[i].Destroyers<0 then begin
          if Base[This.Base].Troops.Race[i].Destroyers>0 then Dec(Base[This.Base].Troops.Race[i].Destroyers);
          This.Hits.Race[i].Destroyers:=100;
        end;
        if (Base[This.Base].Troops.Race[i].Fighters<>0)
        or(Base[This.Base].Troops.Race[i].Bombers<>0)
        or(Base[This.Base].Troops.Race[i].Destroyers<>0) then begin
          Inc(Have);
          Has:=i;
        end;
      end;
      if Have=1 then begin
        if Base[This.Base].Owner<>Has then Base[This.Base].MoveTo:=This.Base;
        Base[This.Base].Owner:=Has;
        if Battles=This then begin
          Battles:=This.Next;
          Base[This.Base].Battle:=False;
          Dispose(This);
        end else begin
          Searcher:=Battles;
          while Searcher.Next<>This do Searcher:=Searcher.Next;
          Searcher.Next:=This.Next;
          Base[This.Base].Battle:=False;
          Dispose(This);
        end;
        break;
      end;
    end;
    This:=This.Next;
  end;
end;

procedure CalcGroups;
var
  i:Integer;
  DX, DY, dst:Single;
begin
  for i:=1 to GROUPS do begin
    with Group[i] do begin
      if Used then begin
        DX:=Base[Dest].X-X;
        DY:=Base[Dest].Y-Y;
        dst:=sqrt(DX*DX+DY*DY);
        if dst<=4*Pps then begin
          Inc(Base[Dest].Troops.Race[Owner].Fighters, Troops.Fighters);
          Inc(Base[Dest].Troops.Race[Owner].Bombers, Troops.Bombers);
          Inc(Base[Dest].Troops.Race[Owner].Destroyers, Troops.Destroyers);
          Dec(Base[Dest].Coming.Race[Owner].Fighters, Troops.Fighters);
          Dec(Base[Dest].Coming.Race[Owner].Bombers, Troops.Bombers);
          Dec(Base[Dest].Coming.Race[Owner].Destroyers, Troops.Destroyers);
          if Owner<>Base[Dest].Owner then begin
            CheckBattle(Dest);
          end;
          If (GameMode=2)and(BView.Base=Dest) then BReInf(Owner, Troops.Fighters, Troops.Bombers, Troops.Destroyers);
          CheckBaseInfo;
          Used:=False;
        end else begin
          DX:=DX*GROUPSPEED*Pps/dst;
          DY:=DY*GROUPSPEED*Pps/dst;
          X:=X+DX;
          Y:=Y+DY;
        end;
      end;
    end;
  end;
end;

procedure CalcBases;
var i:Integer;
begin
  for i:=1 to BASES do begin
    with Base[i] do begin
      CheckRelay(i);
    end;
  end;
end;

function AttackOK(From, Two:Integer):Boolean;
var
  Ok:Boolean;
begin
  Ok:=False;
  if (Base[Two].Troops.Race[Base[From].Owner].Fighters+Base[Two].Coming.Race[Base[From].Owner].Fighters<MAXBASEFIGHTERS)
  and(Base[From].Troops.Race[Base[From].Owner].Fighters-Base[From].Defend.Fighters>0) then Ok:=True;
  if (Base[Two].Troops.Race[Base[From].Owner].Bombers+Base[Two].Coming.Race[Base[From].Owner].Bombers<MAXBASEBOMBERS)
  and(Base[From].Troops.Race[Base[From].Owner].Bombers-Base[From].Defend.Bombers>0) then Ok:=True;
  if (Base[Two].Troops.Race[Base[From].Owner].Destroyers+Base[Two].Coming.Race[Base[From].Owner].Destroyers<MAXBASEDESTROYERS)
  and(Base[From].Troops.Race[Base[From].Owner].Destroyers-Base[From].Defend.Destroyers>0) then Ok:=True;
  if (Base[From].Troops.Race[Base[From].Owner].Fighters-Base[From].Defend.Fighters=0)
  and(Base[From].Troops.Race[Base[From].Owner].Bombers-Base[From].Defend.Bombers=0)
  and(Base[From].Troops.Race[Base[From].Owner].Destroyers-Base[From].Defend.Destroyers=0)
  and(Base[Two].Troops.Race[Base[From].Owner].Fighters+Base[Two].Coming.Race[Base[From].Owner].Fighters<MAXBASEFIGHTERS) then Ok:=True;
  AttackOK:=Ok;
end;

procedure CalcKI;
var
  i, j, Lastmt:Integer;
  dst, dst1, dst2, dstm, dstr:Single;
  n, m:Integer;
begin
  for i:=1 to BASES do begin
    Base[i].Attacked:=False;
    for j:=1 to RACES do begin
      if (j<>Base[i].Owner) then begin
        if (Base[i].Coming.Race[j].Fighters>0)
         or(Base[i].Coming.Race[j].Bombers>0)
         or(Base[i].Coming.Race[j].Destroyers>0) then begin
          Base[i].Attacked:=True;
        end;
      end;
    end;
    Lastmt:=Base[i].MoveTo;
    if (Base[i].Owner<>1)or(Form1.DoTactics1.Checked) then begin
      Base[i].MoveTo:=i;
      dst:=1E40;
      n:=i;
      for j:=1 to BASES do begin
        if ((Base[j].Owner<>Base[i].Owner)or(Base[j].Battle)or(Base[j].Attacked))and(AttackOk(i, j)) then begin
          if sqrt((Base[i].X-Base[j].X)*(Base[i].X-Base[j].X)+(Base[i].Y-Base[j].Y)*(Base[i].Y-Base[j].Y))<dst then begin
            dst:=sqrt((Base[i].X-Base[j].X)*(Base[i].X-Base[j].X)+(Base[i].Y-Base[j].Y)*(Base[i].Y-Base[j].Y));
            n:=j;
          end;
        end;
      end;
      Base[i].MoveTo:=n;
      m:=n;
      dstr:=1E40;
      if n<>i then
      for j:=1 to BASES do begin
        dst1:=sqrt((Base[i].X-Base[j].X)*(Base[i].X-Base[j].X)+(Base[i].Y-Base[j].Y)*(Base[i].Y-Base[j].Y));
        dst2:=sqrt((Base[j].X-Base[n].X)*(Base[j].X-Base[n].X)+(Base[j].Y-Base[n].Y)*(Base[j].Y-Base[n].Y));
        dstm:=sqrt((Base[j].X-(Base[n].X+Base[i].X)/2)*(Base[j].X-(Base[n].X+Base[i].X)/2)+(Base[j].Y-(Base[n].Y+Base[i].Y)/2)*(Base[j].Y-(Base[n].Y+Base[i].Y)/2));
        if (Base[j].Owner=Base[i].Owner)
        and(AttackOk(i, j))
        and(dstm<dst/2)
        and(i<>j)
        and(dst1+dst2<dst*1.5) then begin
          if dst1<dstr then begin
            dstr:=dst1;
            m:=j;
          end;
        end;
      end;
      Base[i].MoveTo:=m;
    end;
    if Lastmt<>Base[i].MoveTo then begin
      if KIOrdersLeft[Base[i].Owner]>0 then begin
        Dec(KIOrdersLeft[Base[i].Owner]);
      end else if GameTime-LastKIOrder[Base[i].Owner]>KIORDERINT then begin
        LastKIOrder[Base[i].Owner]:=GameTime;
        KIOrdersLeft[Base[i].Owner]:=KIORDERNUM;
      end else begin
        if (Base[i].Owner<>1)or(not FAST1KI) then Base[i].MoveTo:=Lastmt;
      end;
    end;
  end;
end;

procedure CalcCReInf;
var
  i:Integer;
begin
  if GameTime-LastCReInfTime>=CREINFINTERVAL then begin
    LastCReInfTime:=GameTime;
    i:=1+Random(BASES);
    Base[i].Troops.Race[Base[i].Owner].Fighters:=
      Min(Base[i].Troops.Race[Base[i].Owner].Fighters+4, MAXBASEFIGHTERS);
    i:=1+Random(BASES);
    Base[i].Troops.Race[Base[i].Owner].Bombers:=
      Min(Base[i].Troops.Race[Base[i].Owner].Bombers+2, MAXBASEBOMBERS);
    i:=1+Random(BASES);
    Base[i].Troops.Race[Base[i].Owner].Destroyers:=
      Min(Base[i].Troops.Race[Base[i].Owner].Destroyers+1, MAXBASEDESTROYERS);
  end;
end;

procedure CalcGameStatus;
var
  i:Integer;
  BHave, OHave:Boolean;
  Re:PReinf;
begin
  if GameMode=1 then begin
    BHave:=False;
    OHave:=False;
    for i:=1 to BASES do begin
      if Base[i].Owner=1 then
        BHave:=True
      else OHave:=True;
    end;
    for i:=1 to GROUPS do begin
      if (Group[i].Used) then begin
        if (Group[i].Owner=1) then begin
          BHave:=True
        end else begin
          OHave:=True;
        end;
      end;
    end;
    if not BHave then begin
      StoryPart:=101;
      StartStory:=True;
    end;
    if not OHave then begin
      Re:=Reinforcements;
      while Re<>nil do begin
        if GameTime<Re.Time then OHave:=True;
        Re:=Re.Next;
      end;
    end;
    if not OHave then begin
      StoryPart:=100;
      StartStory:=True;
    end;
  end;
end;

procedure MapCalculations;
begin
  CalcCReInf;
  if GameTime-CalcBaseTime>CALCBASEINT then begin
    CalcKI;
    CalcBases;
    CalcBaseTime:=Gametime;
    CalcGameStatus;
  end;
  CalcGroups;
  CalcBattles;
end;

procedure Calculations;
var
  i:Integer;
  Re:PReInf;
begin
  inc(cnt);
  GameTime:=GameTime+Pps;
  if (GameMode=1)or(GameMode=2) then begin
    Re:=Reinforcements;
    while Re<>nil do begin
      if (GameTime>=Re.Time) then begin
        if not Re.Done then begin
          if Re.StoryID<>0 then begin
            StoryPart:=Re.StoryID;
            StartStory:=True;
          end;
        end;
        Re.Done:=True;
        if ((Re.Troops.Fighters>0)or(Re.Troops.Bombers>0)or(Re.Troops.Destroyers>0)) then begin
          for i:=1 to NUMREINFBASES do begin
            Dec(Re.Troops.Fighters, Max(Min(Re.Troops.Fighters, MAXBASEFIGHTERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Fighters-Base[ReInfBases.Race[Re.Race].Base[i]].Coming.Race[Re.Race].Fighters), 0));
            Dec(Re.Troops.Bombers, Max(Min(Re.Troops.Bombers, MAXBASEBOMBERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Bombers-Base[ReInfBases.Race[Re.Race].Base[i]].Coming.Race[Re.Race].Bombers), 0));
            Dec(Re.Troops.Destroyers, Max(Min(Re.Troops.Destroyers, MAXBASEDESTROYERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Destroyers-Base[ReInfBases.Race[Re.Race].Base[i]].Coming.Race[Re.Race].Destroyers), 0));
            if Re.Race=3 then begin
              if Random(2)=0 then begin
                Reinforce(Re.Race, 180+Random(76), 0, ReInfBases.Race[Re.Race].Base[i], Max(Min(Re.Troops.Fighters, MAXBASEFIGHTERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Fighters), 0)
                , Max(Min(Re.Troops.Bombers, MAXBASEBOMBERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Bombers), 0)
                , Max(Min(Re.Troops.Destroyers, MAXBASEDESTROYERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Destroyers), 0));
              end else begin
                Reinforce(Re.Race, 256, Random(76), ReInfBases.Race[Re.Race].Base[i], Max(Min(Re.Troops.Fighters, MAXBASEFIGHTERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Fighters), 0)
                , Max(Min(Re.Troops.Bombers, MAXBASEBOMBERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Bombers), 0)
                , Max(Min(Re.Troops.Destroyers, MAXBASEDESTROYERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Destroyers), 0));
              end;
            end;
            if Re.Race=1 then begin
              Reinforce(Re.Race, 100+Random(56), 256, ReInfBases.Race[Re.Race].Base[i], Max(Min(Re.Troops.Fighters, MAXBASEFIGHTERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Fighters), 0)
              , Max(Min(Re.Troops.Bombers, MAXBASEBOMBERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Bombers), 0)
              , Max(Min(Re.Troops.Destroyers, MAXBASEDESTROYERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Destroyers), 0));
            end;
            if Re.Race=2 then begin
              Reinforce(Re.Race, 0, 100+Random(56), ReInfBases.Race[Re.Race].Base[i], Max(Min(Re.Troops.Fighters, MAXBASEFIGHTERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Fighters), 0)
              , Max(Min(Re.Troops.Bombers, MAXBASEBOMBERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Bombers), 0)
              , Max(Min(Re.Troops.Destroyers, MAXBASEDESTROYERS-Base[ReInfBases.Race[Re.Race].Base[i]].Troops.Race[Re.Race].Destroyers), 0));
            end;
          end;
        end;
      end;
      Re:=Re.Next;
    end;
  end;
end;

function MaxF(a, b:Single):Single;
begin
  if a>b then MaxF:=a else MaxF:=b;
end;

function MinF(a, b:Single):Single;
begin
  if a<b then MinF:=a else MinF:=b;
end;

procedure CalcView;
var
  NShip:PBShip;
  MX, MY, LX, LY:Single;
  NVs:PViewSpot;
begin
  if DEBUG then DebugNum(80);
  MX:=-1E40;
  LX:=1E40;
  MY:=-1E40;
  LY:=1E40;
  NShip:=BView.BShips;
  while NShip<>nil do begin
    if DEBUG then DebugNum(81);
    with NShip.Graphic do begin
      if X+40>MX then MX:=X+40;
      if X-40<LX then LX:=X-40;
      if Y+40>MY then MY:=Y+40;
      if Y-40<LY then LY:=Y-40;
    end;
    if DEBUG then DebugNum(82);
    NShip:=NShip.Next;
  end;
  NVs:=BView.ViewSpots;
  while NVs<>nil do begin
    with NVs^ do begin
      if X+40>MX then MX:=X+40;
      if X-40<LX then LX:=X-40;
      if Y+40>MY then MY:=Y+40;
      if Y-40<LY then LY:=Y-40;
    end;
    NVs:=NVs.Next;
  end;
  if BView.BShips<>nil then begin
    if DEBUG then DebugNum(88);
    View.dX:=-(MX+LX)/2;
    if DEBUG then DebugNum(84);
    View.dY:=-(MY+LY)/2;
    if DEBUG then DebugNum(83);
    if ((MX-LX)=0)and(MY-LY=0) then View.dZoom:=1
    else if (MY-LY=0)and(MX-LX<>0) then View.dZoom:=SWidth/(MX-LX)
    else if (MX-LX=0)and(MY-LY<>0) then View.dZoom:=SHeight/(MY-LY)
    else if (MX-LX<>0)and(MY-LY<>0) then View.dZoom:=MinF(SWidth/(MX-LX), SHeight/(MY-LY));
  end;
  if DEBUG then DebugNum(85);
  View.X:=View.X+6*MinF(MaxF(Pps, 0), 1)*(View.dX-View.X);
  View.Y:=View.Y+6*MinF(MaxF(Pps, 0), 1)*(View.dY-View.Y);
  if DEBUG then DebugNum(86);
  View.Zoom:=View.Zoom+6*MinF(MaxF(Pps, 0), 1)*(View.dZoom-View.Zoom);
  if DEBUG then DebugNum(87);
  if View.Zoom>1 then View.Zoom:=1;
  if DEBUG then DebugNum(88);
end;

procedure CalcBGroupTargetKI;
var
  i, j:Integer;
begin
  for i:=1 to RACES do begin
    for j:=1 to RACES do begin
      if (i<>j)and((j<>1)or(Form1.DoBattles1.Checked)) then begin
        if Base[BView.Base].Troops.Race[i].Fighters>0 then begin
          BView.BGroupKI.Race[j].Target[3].Race:=i;
          BView.BGroupKI.Race[j].Target[3].Typ:=1;
        end;
        if Base[BView.Base].Troops.Race[i].Bombers>0 then begin
          BView.BGroupKI.Race[j].Target[1].Race:=i;
          BView.BGroupKI.Race[j].Target[1].Typ:=2;
        end;
        if Base[BView.Base].Troops.Race[i].Destroyers>0 then begin
          BView.BGroupKI.Race[j].Target[2].Race:=i;
          BView.BGroupKI.Race[j].Target[2].Typ:=3;
        end;
      end;
    end;
  end;
end;

procedure CalcBShipTargetKI;
var
  NShip, TShip, GShip:PBShip;
  AtBy:Integer;
begin
  NShip:=BView.BShips;
  while NShip<>nil do begin
    if (NShip.Target=nil)
    or(NShip.Target.Typ<>BView.BGroupKI.Race[NShip.Race].Target[NShip.Typ].Typ)
    or(NShip.Target.Race<>BView.BGroupKI.Race[NShip.Race].Target[NShip.Typ].Race) then begin
      AtBy:=maxint;
      Gship:=nil;
      TShip:=BView.BShips;
      while TShip<>nil do begin
        if (TShip.Race=BView.BGroupKI.Race[Nship.Race].Target[NShip.Typ].Race)
        and(TShip.Typ=BView.BGroupKI.Race[Nship.Race].Target[NShip.Typ].Typ) then begin
          if TShip.KI.AttackedBy<AtBy then begin
            GShip:=TShip;
            AtBy:=TShip.KI.AttackedBy;
          end;
        end;
        TShip:=TShip.Next;
      end;
      if GShip<>nil then begin
        NShip.Target:=GShip;
        Inc(GShip.KI.AttackedBy);
      end;
    end;
    NShip:=NShip.Next;
  end;
  NShip:=BView.BShips;
  while NShip<>nil do begin
    if NShip.Target=nil then begin
      AtBy:=maxint;
      GShip:=nil;
      TShip:=BView.BShips;
      while TShip<>nil do begin
        if (TShip.Race<>NShip.Race) then begin
          if TShip.KI.AttackedBy<AtBy then begin
            GShip:=TShip;
            AtBy:=TShip.KI.AttackedBy;
          end;
        end;
        TShip:=TShip.Next;
      end;
      if GShip<>nil then begin
        NShip.Target:=GShip;
        Inc(GShip.KI.AttackedBy);
      end;
    end;
    if (BView.BGroupKI.Race[NShip.Race].Target[NShip.Typ].Race=0)
    and(BView.BGroupKI.Race[NShip.Race].Target[NShip.Typ].Typ=0)
    and(NShip.KI.AttackedBy=0)
    and(NShip.Race=1)
    and(not Form1.DoBattles1.Checked) then begin
      NShip.Target:=nil;
    end;
    NShip:=NShip.Next;
  end;
end;

procedure DrawShots;
var
  NShot:PShot;
  Len:Single;
  Color:Word;
begin
  Len:=0.5;
  Color:=$3F;
  NShot:=BView.Shots;
  while NShot<>nil do begin
    case NShot.Typ of
      1:begin
          Len:=0.7;
          Color:=$3F;
        end;
      2:begin
          Len:=5;
          Color:=$8410;
        end;
      3:begin
          Len:=2;
          Color:=$F800;
        end;
    end;
    Line(SWidth shr 1+Trunc((NShot.X+View.X)*View.Zoom), SHeight shr 1+Trunc((NShot.Y+View.Y)*View.Zoom)
    , SWidth shr 1+Trunc((NShot.X+NShot.dX/1000*Len+View.X)*View.Zoom), SHeight shr 1+Trunc((NShot.Y+NShot.dY/1000*Len+View.Y)*View.Zoom)
    , Color, pl, SWidth, SHeight);
    NShot:=NShot.Next;
  end;
end;

function sgn(X:Single):single;
var
  r:Single;
begin
  r:=0;
  if X<0 then r:=-1;
  if X=0 then r:=0;
  if X>0 then r:=1;
  sgn:=r;
end;

procedure Shoot(NShip:PBShip);
var
  i, num:Integer;
  NShot:PShot;
  ReloadTime, dst:Single;
begin
  ReloadTime:=1;
  num:=2;
  case NShip.Typ of
    1:ReloadTime:=1;
    2:ReloadTime:=2;
    3:ReloadTime:=0.1;
  end;
  if GameTime-NShip.LastShot>ReloadTime then begin
    case NShip.Typ of
      1:num:=2;
      2:num:=2;
      3:num:=2;
    end;
    for i:=0 to num-1 do begin
      New(NShot);
      if num=2 then begin
        NShot.X:=NShip.Graphic.X+2*(i-0.5)*NShip.Graphic.xx/5000;
        NShot.Y:=NShip.Graphic.Y+2*(i-0.5)*NShip.Graphic.xy/5000;
      end else begin
        NShot.X:=NShip.Graphic.X;
        NShot.Y:=NShip.Graphic.Y;
      end;
      case NShip.Typ of
        1:begin
            NShot.dX:=-NShip.Graphic.yx;
            NShot.dY:=-NShip.Graphic.yy;
            //Playsound(1,'shot.mid', False);
          end;
        2:begin
            NShot.dX:=-NShip.Graphic.yx*0.25;
            NShot.dY:=-NShip.Graphic.yy*0.25;
            //Playsound(1, 'rocket.mid', False);
          end;
        3:begin
            dst:=sqrt((NShip.Target.Graphic.X-NShip.Graphic.X)*(NShip.Target.Graphic.X-NShip.Graphic.X)+(NShip.Graphic.Y-NShip.Target.Graphic.Y)*(NShip.Graphic.Y-NShip.Target.Graphic.Y));
            NShot.dX:=(NShip.Target.Graphic.X-0.0012*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yx-NShip.Graphic.X)*(70+Random(61))/100;
            NShot.dY:=(NShip.Target.Graphic.Y-0.0012*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yx-NShip.Graphic.Y)*(70+Random(61))/100;
            if (NShot.dX<>0)or(NShot.dY<>0) then begin
              if abs(NShot.dX)>abs(NShot.dY) then begin
                NShot.dY:=NShot.dY/abs(NShot.dX)*15512;
                NShot.dX:=15512*sgn(NShot.dX);
              end else begin
                NShot.dX:=NShot.dX/abs(NShot.dY)*15512;
                NShot.dY:=15512*sgn(NShot.dY);
              end;
            end;
            //Playsound(1,'shot.mid', False);
          end;
      end;
      NShot.LaunchedAt:=GameTime;
      NShot.Owner:=NShip.Race;
      NShot.Typ:=NShip.Typ;
      NShot.Next:=BView.Shots;
      BView.Shots:=NShot;
    end;
    NShip.LastShot:=Gametime;
  end;
end;

procedure CalcBShipMovementKI;
var
  NShip:PBShip;
  aot, TX, TY:Single;
  Leftd, Rightd, Adst, dst, MaxTurn:Single;
begin
  if DEBUG then Debugnum(90);
  NShip:=BView.BShips;
  while NShip<>nil do begin
    while NShip.Graphic.Yaw>128 do NShip.Graphic.Yaw:=NShip.Graphic.Yaw-256;
    while NShip.Graphic.Yaw<-128 do NShip.Graphic.Yaw:=NShip.Graphic.Yaw+256;
    MaxTurn:=2;
    case NShip.Typ of
      1:Maxturn:=1.5;
      2:Maxturn:=0.8;
      3:Maxturn:=0.6;
    end;
    if (NShip.KI.State=20)or(NShip.KI.State=21) then begin
      case NShip.Typ of
        1:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+FIGHTERSPEED)*4*Pps;
        2:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+BOMBERSPEED)*4*Pps;
        3:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+DESTROYERSPEED)*4*Pps;
      end;
      NShip.Graphic.dYaw:=0;
      NShip.Graphic.dYawf:=0;
      NShip.Graphic.Pitch:=NShip.Graphic.Pitch+MinF(80*Pps, MaxTurn);
      if NShip.Graphic.Pitch>=128 then begin
        NShip.Graphic.Pitch:=0;
        NShip.Graphic.Roll:=NShip.Graphic.Roll-128+256*Random(2);
        NShip.Graphic.Yaw:=NShip.Graphic.Yaw+128;
        if NShip.KI.State=21 then
          NShip.KI.State:=30
        else
          NShip.KI.State:=0;
      end;
    end else if NShip.KI.State=10 then begin
      case NShip.Typ of
        1:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+3*FIGHTERSPEED*(GameTime-NShip.KI.Since))*4*Pps;
        2:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+3*FIGHTERSPEED*(GameTime-NShip.KI.Since))*4*Pps;
        3:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+2.5*FIGHTERSPEED*(GameTime-NShip.KI.Since))*4*Pps;
      end;
      NShip.Graphic.dYaw:=0;
    end else if (NShip.KI.State=40)or(NShip.KI.State=41) then begin
      case NShip.Typ of
        1:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+FIGHTERSPEED*(GameTime-NShip.KI.Since))*Pps;
        2:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+BOMBERSPEED*(GameTime-NShip.KI.Since))*Pps;
        3:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+DESTROYERSPEED*(GameTime-NShip.KI.Since))*Pps;
      end;
      NShip.Graphic.dYaw:=0;
      if (GameTime-NShip.KI.Since>2)and(NShip.KI.State=40) then begin
        NShip.KI.State:=0;
        NShip.KI.Since:=GameTime;
      end;
      if (GameTime-NShip.KI.Since>2)and(NShip.KI.State=41) then begin
        NShip.KI.State:=10;
        NShip.KI.Since:=GameTime;
      end;
    end else begin
      if (NShip.Target<>nil)or(NShip.KI.State=30) then begin
        case NShip.Typ of
          1:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+FIGHTERSPEED)*4*Pps;
          2:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+BOMBERSPEED)*4*Pps;
          3:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+DESTROYERSPEED)*4*Pps;
        end;
        if NShip.KI.State=30 then begin
          TX:=ClickX-SWidth shr 1;
          TY:=ClickY-SHeight shr 1;
          dst:=sqrt((TX-NShip.Graphic.X)*(TX-NShip.Graphic.X)+(NShip.Graphic.Y-TY)*(NShip.Graphic.Y-TY));
          NShip.Graphic.Speed:=MinF(FIGHTERSPEED*dst/50, FIGHTERSPEED);
          if dst<2 then NShip.Graphic.Speed:=0;
        end else begin
          dst:=sqrt((NShip.Target.Graphic.X-NShip.Graphic.X)*(NShip.Target.Graphic.X-NShip.Graphic.X)+(NShip.Graphic.Y-NShip.Target.Graphic.Y)*(NShip.Graphic.Y-NShip.Target.Graphic.Y));
          TX:=NShip.Target.Graphic.X-0.0015*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yx;
          TY:=NShip.Target.Graphic.Y-0.0015*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yy;
          case NShip.Typ of
            1:begin
                TX:=NShip.Target.Graphic.X-0.0015*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yx;
                TY:=NShip.Target.Graphic.Y-0.0015*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yy;
              end;
            2:begin
                TX:=NShip.Target.Graphic.X-0.0010*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yx;
                TY:=NShip.Target.Graphic.Y-0.0010*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yy;
              end;
            3:begin
                TX:=NShip.Target.Graphic.X-0.0010*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yx;
                TY:=NShip.Target.Graphic.Y-0.0010*dst*NShip.Target.Graphic.Speed*NShip.Target.Graphic.yy;
              end;
          end;
        end;
        dst:=sqrt((TX-NShip.Graphic.X)*(TX-NShip.Graphic.X)+(NShip.Graphic.Y-TY)*(NShip.Graphic.Y-TY));
        if (NShip.Graphic.Y-TY)<>0 then
          aot:=arctan((TX-NShip.Graphic.X)/(NShip.Graphic.Y-TY))*256/(2*PI)
        else aot:=64;
        if (TY>NShip.Graphic.Y)and(aot>0) then aot:=aot-128
        else if (TY>NShip.Graphic.Y)and(aot<=0) then aot:=aot+128;
        Leftd:=1E40;
        Rightd:=1E40;
        if NShip.Graphic.Yaw-aot>0 then Leftd:=NShip.Graphic.Yaw-aot
        else Rightd:=aot-NShip.Graphic.Yaw;
        if (NShip.Graphic.Yaw-aot-256>0)and(NShip.Graphic.Yaw-aot-256<Leftd) then Leftd:=NShip.Graphic.Yaw-aot-256;
        if (NShip.Graphic.Yaw-aot+256>0)and(NShip.Graphic.Yaw-aot+256<Leftd) then Leftd:=NShip.Graphic.Yaw-aot+256;
        if (aot-NShip.Graphic.Yaw-256>0)and(aot-NShip.Graphic.Yaw-256<Rightd) then Rightd:=aot-NShip.Graphic.Yaw-256;
        if (aot-NShip.Graphic.Yaw+256>0)and(aot-NShip.Graphic.Yaw+256<Rightd) then Rightd:=aot-NShip.Graphic.Yaw+256;
        Adst:=MinF(Leftd, Rightd);
        NShip.Graphic.dYawv:=Adst;
        if NShip.KI.State<>1 then begin
          if Leftd<=Rightd then NShip.Graphic.dYaw:=-MaxTurn;
          if Rightd<Leftd then NShip.Graphic.dYaw:=MaxTurn;
        end else begin
          if Leftd<=Rightd then NShip.Graphic.dYaw:=MaxTurn;
          if Rightd<Leftd then NShip.Graphic.dYaw:=-MaxTurn;
          NShip.Graphic.dYawv:=128-NShip.Graphic.dYawv;
        end;
        // Shoot
        if (dst<700)and(Adst<32)and(NShip.Typ<>3)and(NShip.KI.State<>30) then Shoot(NShip);
        if (dst<700)and(NShip.Typ=3) then begin
          Shoot(NShip);
        end;
        // AI
        if (dst<60)and(Adst>48)and(NShip.KI.State=0) then begin
          NShip.KI.State:=1;
          NShip.KI.Since:=GameTime;
        end;
        if (dst>=50)and(Adst>90)and(NShip.KI.State=30) then NShip.KI.State:=21;
        if (dst>=300)and(Adst>90)and(NShip.KI.State=0)and(NShip.Typ<>3)and(Random(100)=0) then NShip.KI.State:=20;
        if ((dst>250)or(GameTime-NShip.KI.Since>2))and(NShip.KI.State=1) then begin
          if (Adst>150)and(NShip.Typ<>3) then NShip.KI.State:=20*Random(2)
          else NShip.KI.State:=0;
          NShip.KI.Since:=GameTime;
        end;
//          Line(SWidth shr 1+Trunc((NShip.Graphic.X+View.X)*View.Zoom), SHeight shr 1+Trunc((NShip.Graphic.Y+View.Y)*View.Zoom), SWidth shr 1+Trunc((TX+View.X)*View.Zoom), SHeight shr 1+Trunc((TY+View.Y)*View.Zoom), $F700, pl, SWidth, SHeight);
{          Line(SWidth shr 1+Trunc((NShip.Graphic.X+View.X)*View.Zoom)
        , SHeight shr 1+Trunc((NShip.Graphic.Y+View.Y)*View.Zoom)
        , SWidth shr 1+Trunc((NShip.Graphic.X+View.X+SinT[trunc(Adst) and 255]*100)*View.Zoom)
        , SHeight shr 1+Trunc((NShip.Graphic.Y-CosT[Trunc(Adst) and 255]*100+View.Y)*View.Zoom)
        , $FFFF, pl, SWidth, SHeight);}
      end else begin
        TX:=NShip.ID*70-100;
        TY:=250+NShip.Typ*80;
        if NShip.Race=2 then TY:=-1000+NShip.Typ*80;
        dst:=sqrt((TX-NShip.Graphic.X)*(TX-NShip.Graphic.X)+(NShip.Graphic.Y-TY)*(NShip.Graphic.Y-TY));
        if (NShip.Graphic.Y-TY)<>0 then
          aot:=arctan((TX-NShip.Graphic.X)/(NShip.Graphic.Y-TY))*256/(2*PI)
        else aot:=64;
        if (TY>NShip.Graphic.Y)and(aot>0) then aot:=aot-128
        else if (TY>NShip.Graphic.Y)and(aot<=0) then aot:=aot+128;
        Leftd:=1E40;
        Rightd:=1E40;
        if NShip.Graphic.Yaw-aot>0 then Leftd:=NShip.Graphic.Yaw-aot
        else Rightd:=aot-NShip.Graphic.Yaw;
        if (NShip.Graphic.Yaw-aot-256>0)and(NShip.Graphic.Yaw-aot-256<Leftd) then Leftd:=NShip.Graphic.Yaw-aot-256;
        if (NShip.Graphic.Yaw-aot+256>0)and(NShip.Graphic.Yaw-aot+256<Leftd) then Leftd:=NShip.Graphic.Yaw-aot+256;
        if (aot-NShip.Graphic.Yaw-256>0)and(aot-NShip.Graphic.Yaw-256<Rightd) then Rightd:=aot-NShip.Graphic.Yaw-256;
        if (aot-NShip.Graphic.Yaw+256>0)and(aot-NShip.Graphic.Yaw+256<Rightd) then Rightd:=aot-NShip.Graphic.Yaw+256;
        Adst:=MinF(Leftd, Rightd);
        NShip.Graphic.dYawv:=Adst;
        case NShip.Typ of
          1:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+MinF(0.01*FIGHTERSPEED*dst,FIGHTERSPEED))*4*Pps;
          2:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+MinF(0.02*BOMBERSPEED*dst,BOMBERSPEED))*4*Pps;
          3:NShip.Graphic.Speed:=NShip.Graphic.Speed+(-NShip.Graphic.Speed+MinF(0.04*DESTROYERSPEED*dst,DESTROYERSPEED))*4*Pps;
        end;
        if (dst<2)and(NShip.Graphic.Speed<0.05) then begin
          NShip.Graphic.Speed:=0;
          if NShip.Race<>2 then begin
            NShip.Graphic.Yaw:=NShip.Graphic.Yaw+MinF(MaxF(-NShip.Graphic.Yaw+NShip.Graphic.Yaw*(1-MinF(MaxF(Pps, 0), 1)), -MaxTurn), MaxTurn);
            NShip.Graphic.Yaw:=NShip.Graphic.Yaw+MinF(MaxF(-NShip.Graphic.Yaw+NShip.Graphic.Yaw*(1-MinF(MaxF(Pps, 0), 1)), -MaxTurn), MaxTurn);
          end else begin
            NShip.Graphic.Yaw:=NShip.Graphic.Yaw+MinF(MaxF((-NShip.Graphic.Yaw+128)*Pps, -MaxTurn), MaxTurn);
            NShip.Graphic.Yaw:=NShip.Graphic.Yaw+MinF(MaxF((-NShip.Graphic.Yaw+128)*Pps, -MaxTurn), MaxTurn);
          end;
          NShip.Graphic.dYaw:=0;
        end else begin
          if Leftd<=Rightd then NShip.Graphic.dYaw:=-MaxTurn;
          if Rightd<Leftd then NShip.Graphic.dYaw:=MaxTurn;
        end;
      end;
    end;
    NShip:=NShip.Next;
  end;
  if DEBUG then Debugnum(91);
end;

procedure CalcBShipMovement;
var
  NShip:PBShip;
  MaxTurn:Single;
begin
  NShip:=BView.BShips;
  while NShip<>nil do begin
    with NShip^.Graphic do begin
      dYawf:=dYawf+(dYaw-dYawf)*MinF(MaxF(Pps*20, 0), 1);
      Yaw:=Yaw+MinF(4*dYawv, 64)*dYaw*MinF(MaxF(Pps, 0), 1);
      MaxTurn:=2;
      case NShip.Typ of
        1:Maxturn:=1.5;
        2:Maxturn:=0.8;
        3:Maxturn:=0.6;
      end;
      Roll:=Roll+MaxF(MinF((-dYawv*dYaw-(Roll-128))*MinF(MaxF(Pps*20, 0), 1), MaxTurn), -MaxTurn);
      X:=X-Speed*yx*Pps/TIMEACC;
      Y:=Y-Speed*yy*Pps/TIMEACC;
    end;
    NShip:=NShip.Next;
  end;
end;

procedure CalcShotMovement;
var
  NShot, Srch:Pshot;
  Life:Integer;
begin
  NShot:=BView.Shots;
  while NShot<>nil do begin
    NShot.X:=NShot.X+0.04*NShot.dX*Pps;
    NShot.Y:=NShot.Y+0.04*NShot.dY*Pps;
    Life:=2;
    case NShot.Typ of
      1:Life:=2;
      2:Life:=5;
      3:Life:=2;
    end;
    if Gametime-NShot.LaunchedAt>Life then begin
      if NShot=BView.Shots then begin
        BView.Shots:=NShot.Next;
        Dispose(NShot);
        NShot:=BView.Shots;
        continue;
      end else begin
        Srch:=BView.Shots;
        while Srch.Next<>NShot do Srch:=Srch.Next;
        Srch.Next:=NShot.Next;
        Dispose(Nshot);
        NShot:=Srch.Next;
        continue;
      end;
    end;
    NShot:=NShot.Next;
  end;
end;

procedure CheckBWon;
var
  NRaces, i:Integer;
  Which:Integer;
  NBat, Srch:PBattle;
begin
  NRaces:=0;
  Which:=1;
  for i:=1 to RACES do begin
    with Base[BView.Base].Troops.Race[i] do begin
      if (Fighters<>0)or(Bombers<>0)or(Destroyers<>0) then begin
        Inc(NRaces);
        Which:=i;
      end;
    end;
  end;
  if NRaces=1 then begin
    Base[BView.Base].Owner:=Which;
    case Which of
      1:Base[BView.Base].Defend.Fighters:=2;
      2:Base[BView.Base].Defend.Fighters:=1;
      3:Base[BView.Base].Defend.Fighters:=3;
    end;
    Base[BView.Base].Battle:=False;
    NBat:=Battles;
    while NBat<>nil do begin
      if NBat.Base=BView.Base then begin
        if NBat=Battles then begin
          Battles:=Battles.Next;
          Dispose(NBat);
          break;
        end else begin
          Srch:=Battles;
          while Srch.Next<>NBat do Srch:=Srch.Next;
          Srch.Next:=NBat.Next;
          Dispose(NBat);
          break;
        end;
      end;
      NBat:=NBat.Next;
    end;
  end;
end;

procedure CalcHitFX(NShip:PBShip; NShot:PShot);
var
  i:Integer;
  X, Y, NX, NY, VX, VY:Single;
begin
  X:=NShot.X-NShip.Graphic.X;
  Y:=NShot.Y-NShip.Graphic.Y;
  NX:=X*CosT[Trunc(NShip.Graphic.Yaw) and 255]+Y*SinT[Trunc(NShip.Graphic.Yaw) and 255];
  NY:=Y*CosT[Trunc(NShip.Graphic.Yaw) and 255]-X*SinT[Trunc(NShip.Graphic.Yaw) and 255];
  VX:=NX;
  VY:=NY;
  if NShip.Hits.Anz<MAXHITFX then begin
    Inc(NShip.Hits.Anz);
    NShip.Hits.X[NShip.Hits.Anz]:=Trunc(VX);
    NShip.Hits.Y[NShip.Hits.Anz]:=Trunc(VY);
  end;
  for i:=0 to NShip.Graphic.VO.Anz do begin
    if (Abs(NShip.Graphic.VO.Vox^[i].X-128-VX)<2)
    and(Abs(NShip.Graphic.VO.Vox^[i].Y-128-VY)<2) then begin
      if Random(2)=0 then
        NShip.Graphic.VO.Vox^[i].Color:=1;
    end
    else if (Abs(NShip.Graphic.VO.Vox^[i].X-128-VX)<4)
    and(Abs(NShip.Graphic.VO.Vox^[i].Y-128-VY)<4) then begin
      if Random(2)=0 then
        NShip.Graphic.VO.Vox^[i].Color:=$F800;
    end;
  end;
end;

procedure CalcHits;
var
  NShip, Nxt:PBShip;
  NShot, Srch:PShot;
  Away:Boolean;
  Area:Integer;
begin
  Away:=False;
  if DEBUG then DebugNum(57);
  NShip:=BView.BShips;
  while NShip<>nil do begin
    Nxt:=NShip.Next;
    NShot:=BView.Shots;
    while NShot<>nil do begin
      Area:=10;
      case NShip.Typ of
        1:Area:=10;
        2:Area:=15;
        3:Area:=20;
      end;
      if (NShip.Race<>NShot.Owner)and(abs(NShip.Graphic.X-NShot.X)<Area)and(abs(NShip.Graphic.Y-NShot.Y)<Area) then begin
        if DEBUG then DebugNum(66);
        case NShot.Typ of
          1:case NShip.Typ of
              1:NShip.Hitp:=NShip.Hitp-4;
              2:NShip.Hitp:=NShip.Hitp-2;
              3:NShip.Hitp:=NShip.Hitp-1;
            end;
          2:case NShip.Typ of
              1:NShip.Hitp:=NShip.Hitp-2;
              2:NShip.Hitp:=NShip.Hitp-2;
              3:NShip.Hitp:=NShip.Hitp-4;
            end;
          3:case NShip.Typ of
              1:NShip.Hitp:=NShip.Hitp-1;
              2:NShip.Hitp:=NShip.Hitp-1;
              3:NShip.Hitp:=NShip.Hitp-1;
            end;
        end;
        if random(3)=0 then CalcHitFX(NShip, NShot);
        if (NShip.Hitp<0)and(NShip.KI.State<>10) then begin
          Explode(NShip, True);
          Away:=True;
        end
        else Away:=False;
        if DEBUG then DebugNum(59);
        if NShot=BView.Shots then begin
          if DEBUG then DebugNum(60);
          BView.Shots:=NShot.Next;
          Dispose(NShot);
          NShot:=BView.Shots;
          if DEBUG then DebugNum(64);
          if not Away then continue;
        end else begin
          if DEBUG then DebugNum(61);
          Srch:=BView.Shots;
          while Srch.Next<>NShot do Srch:=Srch.Next;
          Srch.Next:=NShot.Next;
          if DEBUG then DebugNum(62);
          Dispose(NShot);
          NShot:=Srch.Next;
          if not Away then continue;
        end;
        if Away then break;
        if DEBUG then DebugNum(63);
      end;
      NShot:=NShot.Next;
    end;
    if Away then begin
      CheckBWon;
      NShip:=Nxt;
      continue;
    end;
    NShip:=NShip.Next;
  end;
end;

procedure CalcBKI;
begin
  if KITIMING then StartTimer(2);
  if DEBUG then DebugNum(51);
  if KITIMING then StopTimer(2);
  if KITIMING then StartTimer(3);
  if GameTime-CalcTargetTime>CALCTARGETINT then begin
    CalcBGroupTargetKI;
    CalcBShipTargetKI;
    CalcTargetTime:=Gametime;
  end;
  if DEBUG then DebugNum(52);
  if KITIMING then StopTimer(3);
  if KITIMING then StartTimer(4);
  CalcBShipMovementKI;
  if DEBUG then DebugNum(53);
  if KITIMING then StopTimer(4);
  if KITIMING then StartTimer(5);
  CalcBShipMovement;
  if DEBUG then DebugNum(54);
  if KITIMING then StopTimer(5);
  if KITIMING then StartTimer(6);
  CalcShotMovement;
  if DEBUG then DebugNum(55);
  if KITIMING then StopTimer(6);
  if KITIMING then StartTimer(7);
  CalcHits;
  if DEBUG then DebugNum(56);
  if KITIMING then StopTimer(7);
end;

procedure CalcViewSpots;
var
  NVs, Src:PViewSpot;
begin
  NVs:=BView.ViewSpots;
  while NVs<>nil do begin
    NVs.Timer:=NVs.Timer-Pps;
    if NVs.Timer<=0 then begin
      if NVs=BView.ViewSpots then begin
        Src:=NVs.Next;
        Dispose(NVs);
        BView.ViewSpots:=Src;
        NVs:=Src;
        continue;
      end else begin
        Src:=BView.ViewSpots;
        while Src.Next<>NVs do Src:=Src.Next;
        Src.Next:=NVs.Next;
        Dispose(NVs);
        NVs:=Src.Next;
        continue;
      end;
    end;
    NVs:=NVs.Next;
  end;
end;

procedure TroopCalculations;
begin
  if KITIMING then StartTimer(1);
  if DEBUG then DebugNum(70);
  CalcView;
  CalcViewSpots;
  if KITIMING then StopTimer(1);
  if DEBUG then DebugNum(71);
  CalcBKI;
  if DEBUG then DebugNum(72);
end;

procedure CopyOffscreen;
{var
  Reg:TRegistry;
  Fmt:TPixelFormat;
  Bts:Integer;
  plf, plt:ppixline;}
begin
{  Fmt:=Form1.Image1.Picture.Bitmap.PixelFormat;
  case Fmt of
    pfDevice:begin
               Reg:=TRegistry.Create;
               reg.RootKey:=HKEY_CURRENT_CONFIG;
               if Reg.OpenKey('Display\Settings', False) then begin
                 try
                   Bts:=StrToInt(Reg.ReadString('BitsPerPixel'));
                 except
                   on E:EConvertError do begin
                     Bts:=0;
                   end;
                 end;
                 if Bts<>0 then begin
                   case Bts of
                     16:begin
                          plf:=Addr(pl^[-(SHeight-1)*SWidth]);
                          plt:=Form1.Image1.Picture.Bitmap.Scanline[SHeight-1];
                          Move(plf^, plt^, SWidth*SHeight*2);
//                          Bts:=0;
                        end;
                     else begin
                            Bts:=0;
                          end;
                   end;
                 end;
               end else begin
                 Bts:=0;
               end;
               Reg.Destroy;
             end;
    pf16bit: begin
               plf:=Addr(pl^[-(SHeight-1)*SWidth]);
               plt:=Form1.Image1.Picture.Bitmap.Scanline[SHeight-1];
               Move(plf^, plt^, SWidth*SHeight*2);
               Bts:=16;
             end;
    pf15bit: begin
               plf:=Addr(pl^[-(SHeight-1)*SWidth]);
               plt:=Form1.Image1.Picture.Bitmap.Scanline[SHeight-1];
               Move(plf^, plt^, SWidth*SHeight*2);
               Bts:=15;
             end;
  else
    Bts:=0;
  end;
  case Fmt of
    pfDevice:Form1.Caption:='D';
    pf1Bit:Form1.Caption:='1';
    pf4Bit:Form1.Caption:='4';
    pf8Bit:Form1.Caption:='8';
    pf15Bit:Form1.Caption:='15';
    pf16Bit:Form1.Caption:='16';
    pf24Bit:Form1.Caption:='24';
    pf32Bit:Form1.Caption:='32';
    pfCustom:Form1.Caption:='C';
  end;
  if Bts=0 then}
//  CopyTried := false;
  if Offscreen.Canvas.TryLock then
  begin
    if Form1.Image1.Canvas.TryLock then
    begin
      pl^[0]:=(cnt and 1)*$FFFF;
      pl^[SWidth-1-(SHeight-1)*SWidth]:=(cnt and 1)*$FFFF;
      pl^[-(SHeight-1)*SWidth]:=(cnt and 1)*$FFFF;
      pl^[SWidth-1]:=(cnt and 1)*$FFFF;
      CopyTried := true;
      Form1.Image1.Canvas.Draw(0, 0, Offscreen);
      Form1.Image1.Canvas.UnLock;
    end
    else CopyTried := false;
    Offscreen.Canvas.UnLock;
  end
  else CopyTried := false;
//  Form1.Canvas.Draw(0, 0, Offscreen);
end;

procedure CheckCopied;
begin
  if Form1.Image1.Canvas.TryLock then
  begin
    if (CopyTried)and(Form1.Image1.Canvas.Pixels[0, 0] and 1<>cnt and 1)
     and(Form1.Image1.Canvas.Pixels[SWidth-1, SHeight-1] and 1<>cnt and 1)
     and(Form1.Image1.Canvas.Pixels[0, SHeight-1] and 1<>cnt and 1)
     and(Form1.Image1.Canvas.Pixels[SWidth-1, 0] and 1<>cnt and 1) then begin
      ReInitOffscreen:=True;
    end;
    Form1.Image1.Canvas.UnLock;
  end
end;

procedure HandleClicks;
var
  i, n:Integer;
  dst:Single;
  WF, HF:Single;
  NShip, SShp:PBShip;
  SX, SY:Single;
begin
  if MClick<>0 then begin
    if GameMode=5 then begin
      if MClick=2 then begin
        Credits.Time:=100000000;
      end;
    end;
    if GameMode=2 then begin
      if MClick=1 then begin
        NShip:=nil;
        dst:=1E40;
        SShp:=BView.BShips;
        while SShp<>nil do begin
          SX:=SWidth shr 1+(SShp.Graphic.X+View.X)*View.Zoom;
          SY:=SHeight shr 1+(SShp.Graphic.Y+View.Y)*View.Zoom;
          if (ClickX-SX)*(ClickX-SX)+(ClickY-SY)*(ClickY-SY)<dst then begin
            NShip:=SShp;
            dst:=(ClickX-SX)*(ClickX-SX)+(ClickY-SY)*(ClickY-SY);
          end;
          SShp:=SShp.Next;
        end;
        if NShip.Race=1 then begin
          BView.STypSel:=NShip.Typ;
        end else begin
          if BView.STypSel<>0 then begin
            BView.BGroupKI.Race[1].Target[BView.STypSel].Race:=NShip.Race;
            BView.BGroupKI.Race[1].Target[BView.STypSel].Typ:=NShip.Typ;
            NShip:=BView.BShips;
            while NShip<>nil do begin
              if (NShip.Race=1)and(Nship.Typ=BView.STypSel) then NShip.Target:=nil;
              NShip:=NShip.Next;
            end;
          end;
        end;
      end;
      if MClick=4 then begin
        BView.STypSel:=0;
      end;
    end;
    if GameMode=1 then begin
      WF:=SWidth/256;
      HF:=SHeight/256;
      n:=1;
      dst:=1E40;
      for i:=1 to BASES do begin
        if (ClickX-Base[i].X*WF)*(ClickX-Base[i].X*WF)+(ClickY-Base[i].Y*HF)*(ClickY-Base[i].Y*HF)<dst then begin
          n:=i;
          dst:=(ClickX-Base[i].X*WF)*(ClickX-Base[i].X*WF)+(ClickY-Base[i].Y*HF)*(ClickY-Base[i].Y*HF);
        end;
      end;
      if not MoveOrder then begin
        if NSel<>n then NumSelected:=False;
        NSel:=n;
      end;
      case MClick of
        1:begin
            if MoveOrder then begin
              Form7.Label1.Caption:='Move to '+IntToStr(n);
              if TacticsOrder then Base[NSel].MoveTo:=n
              else DoMoveOnce(NSel, n, Min(Form7.NumSFighters.Position, Base[NSel].Troops.Race[Base[NSel].Owner].Fighters)
                                     , Min(Form7.NumSBombers.Position, Base[NSel].Troops.Race[Base[NSel].Owner].Bombers)
                                     , Min(Form7.NumSDestroyers.Position, Base[NSel].Troops.Race[Base[NSel].Owner].Destroyers));
              CheckBaseInfo;
              MoveOrder:=False;
              TacticsOrder:=False;
              RepaintMap:=True;
            end
            else begin
              Form1.Orders1.Checked:=True;
              CheckBaseInfo;
              Form7.Show;
              if Base[NSel].Owner<>1 then MoveOrder:=False;
              RepaintMap:=True;
            end;
          end;
        2:EnterBattle:=True;
      end;
    end;
    MClick:=0;
  end;
end;

procedure DisplayCredits;
var
  Linen:Integer;
  F:Text;
  Strn:String;
  Fnt:TFont;
  Br:TBrush;
begin
  if not Form1.Pause1.Checked then Credits.Time:=Credits.Time+Pps;
  Fnt:=TFont.Create;
  Fnt.Color:=$02000000+$010101*Trunc($FF*Sin(Credits.Time/10*PI));
  Fnt.Height:=20;
  Fnt.Name:='Arial';
  Offscreen.Canvas.Font.Assign(Fnt);
  Br:=TBrush.Create;
  Br.Color:=clBlack;
  Offscreen.Canvas.Brush.Assign(Br);
//  Application.ProcessMessages;
  Sleep(10);
  if Credits.Time<10 then begin
    if Credits.GameStatus=0 then Offscreen.Canvas.TextOut(Max(SWidth shr 1-120, 0), SHeight shr 1, 'Sorry, You''ve lost the game.');
    if Credits.GameStatus=1 then Offscreen.Canvas.TextOut(Max(SWidth shr 1-120, 0), SHeight shr 1, 'Congratulations! You''ve won the game.');
  end;
  Fnt.Height:=50;
  Fnt.Color:=clWhite;
  Offscreen.Canvas.Font.Assign(Fnt);
  AssignFile(F, 'Data\Game\Credits.dat');
  Reset(F);
  Linen:=0;
  while not Eof(F) do begin
    if Linen=1 then Offscreen.Canvas.Font.Height:=18;
    Readln(F, Strn);
    Offscreen.Canvas.TextOut(Max(SWidth shr 1-80, 0), SHeight-Trunc(Credits.Time*10)+20*Linen, Strn);
    Inc(Linen);
  end;
  if Credits.Time*10>SHeight+Linen*20+20 then Credits.Time:=0;
  CloseFile(F);
  //PlaySound(1,'elise.mid', False);
  LastSaved:=GameTime;
  if Credits.Time-Credits.LastBird>=10 then begin
    //PlaySound(2,'Jungle.wav', False);
    Credits.LastBird:=Credits.Time+Random(30);
  end;
  Fnt.Destroy;
  Br.Destroy;
end;

procedure DisplayIntro;
var
  Fnt:TFont;
  Br:TBrush;
begin
  LastSaved:=Gametime;
  Fnt:=TFont.Create;
  Fnt.Color:=clWhite;
  Fnt.Name:='Arial';
  Fnt.Height:=20;
  Br:=TBrush.Create;
  Br.Color:=clBlack;
  with Offscreen.Canvas do begin
    Font.Assign(Fnt);
    Brush.Assign(Br);
//    Application.ProcessMessages;
    Sleep(10);
    TextOut(50, 10, 'Click Game/New in the Menu to start a new Game!');
    TextOut(50, 40, 'To move ships in the game, click a base, press the "M" key');
    TextOut(50, 60, 'and click a destination base.');
    TextOut(50, 90, 'In the Orders window you can select how many ships you''d');
    TextOut(50, 110, 'like to leave in the base as a defense.');
    TextOut(50, 140, 'You can also send particular ships, for example Destroyers,');
    TextOut(50, 160, 'by selecting them in the "Number to move" part of the orders');
    TextOut(50, 180, 'window and then using the "T" key to move them.');
    TextOut(50, 210, 'Fighters are strong against bombers,');
    TextOut(50, 230, 'bombers are strong against destroyers and');
    TextOut(50, 250, 'destroyers are strong against fighters.');
    TextOut(50, 280, 'By doubleclicking an attacked base you can enter the battle mode.');
    TextOut(50, 300, 'Return to Tactics Mode by clicking "To Tactics Map" in the menu.');
    TextOut(50, 320, 'When the story is displayed you can doubleclick to exit.');
    TextOut(50, 350, 'For more help look at the included how-to-play.html');
    TextOut(50, 370, 'Get Updates and other stuff at:');
    TextOut(50, 390, 'http://go.to/infinitysoftware');
    TextOut(50, 410, 'support and info: empgodot@gmx.de');
  end;
  Fnt.Destroy;
  Br.Destroy;
end;

procedure CheckPlayers;
{var
  i:Integer;
  mp:^TMediaPlayer;}
begin
{  for i:=1 to SOUNDS do begin
    mp:=addr(Form1.MediaPlayer1);
    if MState[i]<>0 then begin
      case i of
        1:mp:=addr(Form1.MediaPlayer1);
        2:mp:=addr(Form1.MediaPlayer2);
      end;
    end;
    with mp^ do begin
      if MState[i]=64 then begin
        Play;
        MState[i]:=1;
      end
      else if (MState[i]=1)and(Mode=mpPlaying) then begin
        MState[i]:=2;
      end
      else if (MState[i]=1)and(Mode<>mpPlaying) then begin
        Play;
      end
      else if (MState[i]=2)and(Mode<>mpPlaying) then begin
        MState[i]:=0;
      end
      else if (MState[i]=3)and(Mode<>mpPlaying) then begin
        Rewind;
        MState[i]:=4;
      end
      else if (MState[i]=4)and(Mode<>mpPlaying)and(Mode<>mpSeeking) then begin
        Play;
        MState[i]:=1;
      end
      else if MState[i]=64+1 then begin
        MState[i]:=1;
      end
      else if MState[i]=64+2 then begin
        Stop;
        MState[i]:=3;
      end
      else if MState[i]=64+3 then begin
        MState[i]:=3;
      end
      else if MState[i]=64+4 then begin
        MState[i]:=4;
      end;
    end;
  end;}
end;

procedure DoLoadGame;
var
  F:File;
  AnzSaves, i, SSel, Num:Integer;
  Str:String[39];
  FName:String;
  Re:PReInf;
  Bat:PBattle;
  Shp:PBShip;
  Sht:PShot;
begin
  Form1.Pause1.Checked:=True;
  Form6.Button1.Caption:='Load';
  Form6.Listbox1.Clear;
  Form6.Edit1.Visible:=False;
  Filecom:=0;
  AssignFile(F, 'Data\Game\sinf.dat');
  Reset(F, 1);
  BlockRead(F, AnzSaves, 4);
  if AnzSaves<>0 then begin
    for i:=0 to AnzSaves-1 do begin
      BlockRead(F, Str, 40);
      Form6.Listbox1.Items.Add(Str);
    end;
  end else begin
    Form6.Listbox1.Items.Add('<no savegames available>');
  end;
  Form6.Show;
  while Filecom=0 do
  begin
    Sleep(10);
    Application.ProcessMessages;
  end;
  Form6.Hide;
  SSel:=Form6.ListBox1.ItemIndex;
  if (Form6.ListBox1.ItemIndex=-1)
  or(Form6.Edit1.Text<>Form6.ListBox1.Items.Strings[Form6.ListBox1.ItemIndex]) then begin
    Filecom:=2;
  end;
  if Filecom=1 then begin
    if LOADDEBUG then DebugNum(1001);
    CloseFile(F);
    FName:='Data\Saves\save'+IntToStr(SSel)+'.neb';
    AssignFile(F, FName);
    Reset(F, 1);
    if LOADDEBUG then DebugNum(1002);
    // load...
    InitStars;
    if NebulaMap<>nil then begin
      if LOADDEBUG then DebugNum(1101);
      if not NebulaMap.Empty then NebulaMap.Destroy;
    end;
    if LOADDEBUG then DebugNum(1100);
    // Name of the Savegame
    BlockRead(F, Str, 40);
    if Str<>Form6.Edit1.Text then ReInitGame:=True;
    // Num
    BlockRead(F, SSel, 4);
    // Game
    if LOADDEBUG then DebugNum(1003);
    BlockRead(F, GameTime, SizeOf(Single));
    BlockRead(F, GameMode, 4);
    BlockRead(F, StoryPart, 4);
    BlockRead(F, NumSelected, SizeOf(Boolean));
    BlockRead(F, CalcBaseTime, SizeOf(Single));
    BlockRead(F, Pps, SizeOf(Single));
    BlockRead(F, Fps, SizeOf(Single));
    BlockRead(F, cnt, SizeOf(LongInt));
    BlockRead(F, LastSmokeTime, SizeOf(Single));
    BlockRead(F, LastKIOrder, SizeOf(LastKIOrder));
    BlockRead(F, KIOrdersLeft, SizeOf(KIOrdersLeft));
    if LOADDEBUG then DebugNum(1004);
    if GameMode=2 then begin
      BlockRead(F, Smoke, SizeOf(Smoke));
    end;
    BlockRead(F, Tm1, SizeOf(Tm1));
    BlockRead(F, Tm2, SizeOf(Tm2));
    BlockRead(F, Msecs, SizeOf(Msecs));
    BlockRead(F, LastTm, SizeOf(Comp));
    if LOADDEBUG then DebugNum(1005);
    if (GameMode=1)or(GameMode=2)or((GameMode=5)and(StoryPart<>0)) then begin
      BlockRead(F, MyRandSeed, sizeOf(LongInt));
      CreateNebulaMap(MyRandSeed);
    end;
    if LOADDEBUG then DebugNum(1006);
    BlockRead(F, Base, SizeOf(Base));
    BlockRead(F, NSel, 4);
    BlockRead(F, Group, SizeOf(Group));
    BlockRead(F, LastCReInfTime, SizeOf(Single));
    if LOADDEBUG then DebugNum(1007);
    while BView.BShips<>nil do begin
      Shp:=BView.BShips.Next;
      BView.BShips.Graphic.VO.Destroy;
      Dispose(BView.BShips);
      BView.BShips:=Shp;
    end;
    if LOADDEBUG then DebugNum(1008);
    while BView.Shots<>nil do begin
      Sht:=BView.Shots.Next;
      Dispose(BView.Shots);
      BView.Shots:=Sht;
    end;
    if LOADDEBUG then DebugNum(1009);
    BlockRead(F, BView, SizeOf(BView));
    BlockRead(F, View, SizeOf(View));
    BView.BShips:=nil;
    BView.Shots:=nil;
    if LOADDEBUG then DebugNum(1010);
    while Reinforcements<>nil do begin
      Re:=Reinforcements.Next;
      Dispose(Reinforcements);
      Reinforcements:=Re;
    end;
    if LOADDEBUG then DebugNum(1011);
    BlockRead(F, Num, 4);
    if Num>0 then
    for i:=1 to Num do begin
      New(Re);
      BlockRead(F, Re^, SizeOf(Re^));
      Re.Next:=Reinforcements;
      Reinforcements:=Re;
    end;
    if LOADDEBUG then DebugNum(1012);
    BlockRead(F, ReInfBases, SizeOf(ReInfBases));
    while Battles<>nil do begin
      Bat:=Battles.Next;
      Dispose(Battles);
      Battles:=Bat;
    end;
    if LOADDEBUG then DebugNum(1013);
    Battles:=nil;
    BlockRead(F, Num, 4);
    if Num>0 then
    for i:=1 to Num do begin
      New(Bat);
      BlockRead(F, Bat^, SizeOf(Bat^));
      Bat.Next:=Battles;
      Battles:=Bat;
    end;
    if LOADDEBUG then DebugNum(1014);
    if (GameMode=2)or(GameMode=4) then begin
      BlockRead(F, Num, 4);
      if LOADDEBUG then DebugNum(1015);
      if Num>0 then
      for i:=1 to Num do begin
        New(Shp);
        BlockRead(F, Shp^, SizeOf(Shp^));
        Shp^.Graphic.VO:=TVoxelObj.Create;
        BlockRead(F, Shp^.Graphic.VO.Anz, 4);
        BlockRead(F, Shp^.Graphic.VO.AnzPlane, 4);
        GetMem(Shp^.Graphic.VO.Vox, Shp^.Graphic.VO.Anz*SizeOf(TVoxel));
        GetMem(Shp^.Graphic.VO.Plane, Shp^.Graphic.VO.AnzPlane*SizeOf(TVoxel));
        BlockRead(F, Shp^.Graphic.VO.Vox^, Shp^.Graphic.VO.Anz*SizeOf(TVoxel));
        BlockRead(F, Shp^.Graphic.VO.Plane^, Shp^.Graphic.VO.AnzPlane*SizeOf(TVoxel));
        Shp.Next:=BView.BShips;
        BView.BShips:=Shp;
      end;
      if LOADDEBUG then DebugNum(1016);
    end;
    if GameMode=2 then begin
      if LOADDEBUG then DebugNum(1017);
      BlockRead(F, Num, 4);
      if Num>0 then
      for i:=1 to num do begin
        New(Sht);
        BlockRead(F, Sht^, SizeOf(Sht^));
        Sht.Next:=BView.Shots;
        BView.Shots:=Sht;
      end;
      if LOADDEBUG then DebugNum(1018);
    end;
  end;
  if LOADDEBUG then DebugNum(1019);
  CloseFile(F);
  LoadGame:=False;
  Filecom:=0;
  Form1.Pause1.Checked:=False;
end;

procedure DoSaveGame;
var
  F:File;
  AnzSaves, SSel, i, num:Integer;
  Str:String[39];
  FName:String;
  Re:PReInf;
  Bat:PBattle;
  Shp:PBShip;
  Sht:PShot;
begin
//  Sleep(10);
  Form1.Pause1.Checked:=True;
  Form6.Button1.Caption:='Save';
  Form6.Edit1.Text:='<name of new savegame>';
  Form6.Listbox1.Clear;
  Form6.Edit1.Visible:=True;
  Filecom:=0;
  AssignFile(F, 'Data\Game\sinf.dat');
  Reset(F, 1);
  BlockRead(F, AnzSaves, 4);
  if AnzSaves<>0 then begin
    for i:=1 to AnzSaves do begin
      BlockRead(F, Str, 40);
      Form6.Listbox1.Items.Add(Str);
    end;
  end else begin
    Form6.Listbox1.Items.Add('<no savegames available>');
  end;
  Filecom := 0;
  Form6.Show;
  while Filecom=0 do
  begin
    Sleep(10);
    Application.ProcessMessages;
  end;
  Form6.Hide;
  SSel:=Form6.ListBox1.ItemIndex;
  if (Form6.ListBox1.ItemIndex=-1)
  or(Form6.Edit1.Text<>Form6.ListBox1.Items.Strings[SSel]) then SSel:=AnzSaves;
  if Form6.Edit1.Text='' then Filecom:=2;
  if Filecom=1 then begin
    if (SSel=Anzsaves) then begin
      Seek(F, 0);
      Inc(AnzSaves);
      BlockWrite(F, AnzSaves, 4);
      Seek(F, 4+SSel*40);
      Str:=Form6.Edit1.Text;
      BlockWrite(F, Str, 40);
    end;
    CloseFile(F);
    FName:='Data\Saves\save'+IntToStr(SSel)+'.neb';
    AssignFile(F, FName);
    ReWrite(F, 1);
    // save...
    // Name of the Savegame
    Str:=Form6.Edit1.Text;
    BlockWrite(F, Str, 40);
    // Num
    BlockWrite(F, SSel, 4);
    // Game
    BlockWrite(F, GameTime, SizeOf(Single));
    BlockWrite(F, GameMode, 4);
    BlockWrite(F, StoryPart, 4);
    BlockWrite(F, NumSelected, SizeOf(Boolean));
    BlockWrite(F, CalcBaseTime, SizeOf(Single));
    BlockWrite(F, Pps, SizeOf(Single));
    BlockWrite(F, Fps, SizeOf(Single));
    BlockWrite(F, cnt, SizeOf(LongInt));
    BlockWrite(F, LastSmokeTime, SizeOf(Single));
    BlockWrite(F, LastKIOrder, SizeOf(LastKIOrder));
    BlockWrite(F, KIOrdersLeft, SizeOf(KIOrdersLeft));
    if GameMode=2 then begin
      BlockWrite(F, Smoke, SizeOf(Smoke));
    end;
    BlockWrite(F, Tm1, SizeOf(Tm1));
    BlockWrite(F, Tm2, SizeOf(Tm2));
    BlockWrite(F, Msecs, SizeOf(Msecs));
    BlockWrite(F, LastTm, SizeOf(Comp));
    if (GameMode=1)or(GameMode=2)or((GameMode=5)and(StoryPart<>1)) then begin
      BlockWrite(F, MyRandSeed, SizeOf(LongInt));
    end;
    BlockWrite(F, Base, SizeOf(Base));
    BlockWrite(F, NSel, 4);
    BlockWrite(F, Group, SizeOf(Group));
    BlockWrite(F, LastCReInfTime, SizeOf(Single));
    BlockWrite(F, BView, SizeOf(BView));
    BlockWrite(F, View, SizeOf(View));
    Re:=Reinforcements;
    Num:=0;
    while Re<>nil do begin
      Inc(Num);
      Re:=Re.Next;
    end;
    BlockWrite(F, Num, 4);
    Re:=Reinforcements;
    while Re<>nil do begin
      BlockWrite(F, Re^, SizeOf(Re^));
      Re:=Re.Next;
    end;
    BlockWrite(F, ReInfBases, SizeOf(ReInfBases));
    Bat:=Battles;
    Num:=0;
    while Bat<>nil do begin
      Inc(Num);
      Bat:=Bat.Next;
    end;
    BlockWrite(F, Num, 4);
    Bat:=Battles;
    while Bat<>nil do begin
      BlockWrite(F, Bat^, SizeOf(Bat^));
      Bat:=Bat.Next;
    end;
    if (GameMode=2)or(GameMode=4) then begin
      Shp:=BView.BShips;
      Num:=0;
      while Shp<>nil do begin
        Inc(Num);
        Shp:=Shp.Next;
      end;
      BlockWrite(F, Num, 4);
      Shp:=BView.BShips;
      while Shp<>nil do begin
        BlockWrite(F, Shp^, SizeOf(Shp^));
        BlockWrite(F, Shp^.Graphic.VO.Anz, 4);
        BlockWrite(F, Shp^.Graphic.VO.AnzPlane, 4);
        BlockWrite(F, Shp^.Graphic.VO.Vox^, Shp^.Graphic.VO.Anz*SizeOf(TVoxel));
        BlockWrite(F, Shp^.Graphic.VO.Plane^, Shp^.Graphic.VO.AnzPlane*SizeOf(TVoxel));
        Shp:=Shp.Next;
      end;
    end;
    if GameMode=2 then begin
      Sht:=BView.Shots;
      Num:=0;
      while Sht<>nil do begin
        Inc(Num);
        Sht:=Sht.Next;
      end;
      BlockWrite(F, Num, 4);
      Sht:=BView.Shots;
      while Sht<>nil do begin
        BlockWrite(F, Sht^, SizeOf(Sht^));
        Sht:=Sht.Next;
      end;
    end;
    LastSaved:=GameTime;
    SaveCanceled:=False;
  end;
  CloseFile(F);
  if FileCom=2 then SaveCanceled:=True;
  SaveGame:=False;
  Filecom:=0;
  Form1.Pause1.Checked:=False;
  Sleep(10);
end;

procedure DrawStars;
var
  i:Integer;
  X,Y:Integer;
begin
  for i:=1 to NUMSTARS do begin
    X:=SWidth div 2+Trunc((Stars[i].X+View.X)*View.zoom*Stars[i].Z);
    Y:=SHeight div 2+Trunc((Stars[i].Y+View.Y)*View.zoom*Stars[i].Z);
    if (X>=0)and(X<SWidth)and(Y>=0)and(Y<SHeight) then begin
      pl^[X-SWidth*Y]:=Stars[i].Color;
    end;
  end;
end;

procedure DoStartStory;
begin
  GameMode:=5;
  Credits.Time:=0;
  StartStory:=False;
{  case StoryPart of
    101:PlaySound(1, 'lost.mid', True);
  else
    PlaySound(1, 'miss.mid', True);
  end;}  
end;

procedure DoStartGame;
begin
  StoryPart:=1;
  DoStartStory;
  StartGame:=False;
end;

procedure DisplayStory;
var
  Linen:Integer;
  F:Text;
  Strn:String;
  Fnt:TFont;
  Br:TBrush;
begin
  if not Form1.Pause1.Checked then Credits.Time:=Credits.Time+Pps;
  Br:=TBrush.Create;
  Br.Color:=clBlack;
  Offscreen.Canvas.Brush.Assign(Br);
  Fnt:=TFont.Create;
  Fnt.Name:='Arial';
  Fnt.Height:=50;
  Fnt.Color:=clWhite;
  Offscreen.Canvas.Font.Assign(Fnt);
  case StoryPart of
    1:AssignFile(F, 'Data\Story\Intro.sry');
    2:AssignFile(F, 'Data\Story\Kyon.sry');
    3:AssignFile(F, 'Data\Story\inter.sry');
    4:AssignFile(F, 'Data\Story\two.sry');
    5:AssignFile(F, 'Data\Story\tree.sry');
    100:AssignFile(F, 'Data\Story\alice.sry');
    101:AssignFile(F, 'Data\Story\fate.sry');
  end;
  Reset(F);
  Linen:=0;
    Sleep(10);
//  Application.ProcessMessages;
  while not Eof(F) do begin
    if Linen=1 then Offscreen.Canvas.Font.Height:=18;
    Readln(F, Strn);
    Offscreen.Canvas.TextOut(Max(SWidth shr 1-200, 0), SHeight-Trunc(Credits.Time*7)+20*Linen, Strn);
    Inc(Linen);
  end;
  if Credits.Time*7>SHeight+Linen*20+20 then begin
    if StoryPart=1 then ReInitGame:=True;
    GameMode:=1;
    if StoryPart=100 then begin
      Credits.GameStatus:=1;
      GameMode:=3;
      InitCredits;
    end;
    if StoryPart=101 then begin
      Credits.GameStatus:=0;
      GameMode:=3;
      InitCredits;
    end;
  end;
  CloseFile(F);
{  case StoryPart of
    101:PlaySound(1,'Lost.mid', False);
  else
    PlaySound(1,'miss.mid', False);
  end;}
  Fnt.Destroy;
  Br.Destroy;
end;

procedure MyThread.Execute;
var
  FirstRun:Boolean;
begin
  { Platzen Sie den Thread code hier }
  if SOUNDDEBUG then DebugNum(103);
  FirstRun:=True;
  Form5.ProgressBar1.Position:=2;
  Form5.Label2.Caption:='2%';
  Priority:=tpNormal;
  Init;
  Form5.ProgressBar1.Position:=100;
  Form5.Label2.Caption:='100%';
  Form5.Hide;
  if DEBUG then DebugNum(0);
  while not Terminated do begin
    if SOUNDDEBUG then DebugNum(104);
    Application.ProcessMessages;
//    Application.Wait(10);
    Sleep(10);
    try
      // GameMode Changes
      if BLOCKTIMING then StartTimer(1);
      if DEBUG then DebugNum(1);
      if EnterCredits then begin
        if MOREDEBUG then DebugNum(2000);
        GameMode:=3;
        Credits.Gamestatus:=2;
        InitCredits;
        EnterCredits:=False;
        if MOREDEBUG then DebugNum(2001);
      end;
      if MOREDEBUG then DebugNum(2002);
      if LoadGame then DoLoadGame;
      if MOREDEBUG then DebugNum(2003);
      if SaveGame then DoSaveGame;
      if MOREDEBUG then DebugNum(2004);
      if StartGame then DoStartGame;
      if MOREDEBUG then DebugNum(2005);
      if StartStory then DoStartStory;
      if MOREDEBUG then DebugNum(2006);
      if ReInitGame then DoReInitGame;
      if MOREDEBUG then DebugNum(2007);
      if MOREDEBUG then DebugNum(2009);
      if BLOCKTIMING then StopTimer(1);
      // Mouse
      if MOREDEBUG then DebugNum(2010);
      HandleClicks;
      if MOREDEBUG then DebugNum(2011);
      if not Form1.Pause1.Checked then Calculations;
      if MOREDEBUG then DebugNum(2012);
      // Calcs, Battle<->Map
      if DEBUG then DebugNum(2);
      if (GameMode=1)or(GameMode=2) then begin
        if MOREDEBUG then DebugNum(2013);
        if BLOCKTIMING then StartTimer(2);
        if EnterBattle then DoEnterBattle;
        if MOREDEBUG then DebugNum(2014);
        if LeaveBattle then DoLeaveBattle;
        if MOREDEBUG then DebugNum(2015);
        if not Form1.Pause1.Checked then MapCalculations;
        if MOREDEBUG then DebugNum(2016);
        if BLOCKTIMING then StopTimer(2);
      end;
      if MOREDEBUG then DebugNum(2017);
      if DEBUG then DebugNum(3);
      // Media
      // CheckPlayers;
      if MOREDEBUG then DebugNum(2018);
      if Offscreen.Canvas.TryLock then begin
        case GameMode of
          1:begin
              if DEBUG then DebugNum(4);
              if MOREDEBUG then DebugNum(2019);
              DoRepaintMap;
              if MOREDEBUG then DebugNum(2020);
              PlayTheme(False);
              if MOREDEBUG then DebugNum(2021);
            end;
          2:begin
              if BLOCKTIMING then StartTimer(3);
              if DEBUG then DebugNum(6);
              DrawBackground;
              if BLOCKTIMING then StopTimer(3);
              Timing(False);
              if BLOCKTIMING then StartTimer(4);
              if DEBUG then DebugNum(7);
              if not Form1.Pause1.Checked then CalcSmoke;
              if BLOCKTIMING then StopTimer(4);
              if BLOCKTIMING then StartTimer(5);
              if DEBUG then DebugNum(8);
              DrawStars;
              DrawSmoke;
              if BLOCKTIMING then StopTimer(5);
              if BLOCKTIMING then StartTimer(6);
              if DEBUG then DebugNum(9);
              DrawVGraphics;
              DrawShots;
              if BLOCKTIMING then StopTimer(6);
              if BLOCKTIMING then StartTimer(7);
              if DEBUG then DebugNum(10);
              if not Form1.Pause1.Checked then TroopCalculations;// behind VGraphics!
              if BLOCKTIMING then StopTimer(7);
            end;
          3:begin
              if MOREDEBUG then DebugNum(2022);
              ClearBuffers;
              if MOREDEBUG then DebugNum(2023);
              Timing(False);
              if MOREDEBUG then DebugNum(2024);
              DisplayCredits;
              if MOREDEBUG then DebugNum(2025);
            end;
          4:begin
              if MOREDEBUG then DebugNum(2026);
              ClearBuffers;
              if MOREDEBUG then DebugNum(2027);
              Timing(False);
              if MOREDEBUG then DebugNum(2028);
              DisplayIntro;
              if MOREDEBUG then DebugNum(2029);
              DrawVGraphics;
              if MOREDEBUG then DebugNum(2030);
              CalcBShipMovementKI;
              if MOREDEBUG then DebugNum(2031);
              CalcBShipMovement;
              if MOREDEBUG then DebugNum(2032);
            end;
          5:begin
              if MOREDEBUG then DebugNum(2033);
              ClearBuffers;
              if MOREDEBUG then DebugNum(2034);
              Timing(False);
              if MOREDEBUG then DebugNum(2035);
              DisplayStory;
              if MOREDEBUG then DebugNum(2036);
            end;
        end;
        Offscreen.Canvas.UnLock;
      end;
      if DEBUG then DebugNum(11);
      if BLOCKTIMING then StartTimer(8);
      if DEBUG then DebugNum(12);
      CopyOffscreen;
      // Graphics Security
      if not FirstRun then CheckCopied;
      if MOREDEBUG then DebugNum(2008);
      if ReInitOffscreen then DoReInitOffscreen;
      if DEBUG then DebugNum(13);
      if BLOCKTIMING then StopTimer(8);
      FirstRun:=False;
    except
      on E:EInvalidOperation do ;//if DEBUG then DebugNum(13);
    end;
  end;
  Finished:=True;
end;

end.
